//var phonecatApp = angular.module("famous", ["famousControllers", "famousServices", "famousFilters", "ngRoute"]);

var app = angular.module("famous", ["ngRoute", "ngLoad", "famousControllers", "famousServices", "famousServicesViews", "famousServicesLang", "famousFilters"]);
app.config(['$routeProvider', function($routeProvider){
	
	$routeProvider.when("/main", {
		templateUrl: 'partials/main.html',
	}).when("/login", {
		templateUrl: 'partials/login.html',
		controller: 'loginCtrl'
	}).when("/tasks", {
		templateUrl: 'partials/tasks.html',
	}).when("/earn", {
		templateUrl: 'partials/earn.html',
		controller: 'earnCtrl'
	}).when("/bid_like", {
		templateUrl: 'partials/bid_like.html',
		controller: 'bidLikeCtrl'
	}).when("/bid_subs", {
		templateUrl: 'partials/bid_subs.html',
		controller: 'bidSubsCtrl'
	}).when("/donate/:id", {
		templateUrl: 'partials/donate.html',
		controller: 'donateCtrl'
	}).when("/settings", {
		templateUrl: 'partials/settings.html',
		controller: 'settingsCtrl'
	}).when("/news", {
		templateUrl: 'partials/news.html',
		controller: 'newsCtrl'
	}).when("/authtrouble", {
		templateUrl: 'partials/authtrouble.html',
		controller: 'authtroubleCtrl'
	}).when("/top", {
		templateUrl: 'partials/top.html',
		controller: 'topCtrl'
	}).when("/lvlprize", {
		templateUrl: 'partials/lvlprize.html',
		controller: 'lvlPrizeCtrl'
	}).when("/privacy", {
		templateUrl: 'partials/privacy.html',
		controller: 'privacyCtrl'
	})
	.otherwise({
		redirectTo: '/login'
	});
}]);

app.config(['$provide', function ($provide) {
    $provide.decorator('$exceptionHandler', ['$delegate', function($delegate) {
		return function (exception, cause) {
			$delegate(exception, cause);
			Manager.instance.getConnector().error(exception.message, exception.stack, function(){});
		};
	}]);
}]);

window.onload = function(){}