var controllers = angular.module("famousControllers", []);

controllers.controller("dialogCtrl", ["$scope", "$rootScope", "$manager", "$action", "$correct", "$dialogView", "$dialogLang",
						function($scope, $rootScope, $manager, $action, $correct, $dialogView, $dialogLang){

	$scope.response = function(response){
		$dialogView.manageView($scope, response);
	}

	$scope.hideDialogBidLikes = function(){
		$dialogView.hideDialogBidLikes();
	}

	$scope.hideCloseAcc = function(){
		$dialogView.hideCloseAcc();
	}
	
	$scope.type = Constant.LIKE_TYPE;
	
	$scope.bid = function(){
		$scope.link = Constant.HOME_PAGE + "watch?v=" +$scope.bidLikeId;
		$dialogView.setButAnim(true);
		/*var status = $correct.checkCorrect('like', $scope.link, $scope.targetCountDialog);

		if(status.status == Constant.OK_STATUS){*/
			$action.bid($scope, new Bid($scope.link, $scope.targetCountDialog, $scope.type));
		/*}else if(status.status == Constant.ERR_STATUS){
			$dialogView.setButAnim(false);
			$dialogView.showToast(status.message);
		}*/
	}

	$scope.changePrice = function(){
		if($scope.targetCountDialog >= 0 && $scope.targetCountDialog != '')
			$dialogView.setPrice($scope, $scope.targetCountDialog * Constant.LIKE_PRICE, 1);
		else
			$dialogView.setPrice($scope, $scope.targetCountDialog * Constant.LIKE_PRICE, 2);
	}

	$dialogView.showLoadingStart();
	
	$dialogLang.setLang($scope);
}]);


controllers.controller("loginCtrl", ["$scope", "$routeParams", "$rootScope", "$location", "$auth", "$loginView", "$loginLang", "$dialogView", "$demon", "$way", "$tracker",
						function($scope, $routeParams, $rootScope, $location, $auth, $loginView, $loginLang, $dialogView, $demon, $way, $tracker){
	$way.step($scope, "/login");
	$scope.auth = function(){
		$dialogView.showLoading();
		$auth.auth($scope);
	}
	
	$scope.response = function(response){
		$loginView.manageView($scope, response);
		setTimeout(function(){
			$dialogView.hideLoading();
		}, 700);
	}

	$loginLang.setLang($scope);

	$loginView.initParams();

	$auth.preload($scope);
}]);

controllers.controller("newsCtrl", ["$scope", "$rootScope", "$action", "$newsView", "$dialogView", "$navView", "$way",
						function($scope, $rootScope, $action, $newsView, $dialogView, $navView, $way){
	$rootScope.locationTitle = $dialogView.strings.newsTitle;
	$way.step($scope, "/news");
	$scope.response = function(response){
		$newsView.manageView($scope, response);
		setTimeout(function(){
			$newsView.show();
			$dialogView.hideLoading();
		}, 600);
	}
	
	$scope.complite = function(id, value){
		//need to remove after few releases 26.02.2016
	}
	
	$scope.compliteFull = function(name, id, message, value){
		$action.complite(name, id, message, value, $scope);
	}
	
	$scope.news = function(){
		$dialogView.showLoading();
		$action.news($scope);
	}
	
	$scope.setHeight = function(){
		return $newsView.setHeight();
	}
	
	$scope.news();

	$newsView.initParams();
	
	$navView.designateBut("newsTab");
}]);

controllers.controller("donateCtrl", ["$scope", "$rootScope", "$routeParams", "$donateView", "$store", "$donateLang", "$dialogView", "$navView", "$way",
						function($scope, $rootScope, $routeParams, $donateView, $store, $donateLang, $dialogView, $navView, $way){
	$rootScope.locationTitle = $dialogView.strings.donateTitle;
	$way.step($scope, "/donate/diamonds");
	$scope.order = function(id){
		$store.order(id);
	}
	
	$scope.init = function(){
		$store.init($scope.response);
	}
	
	$scope.response = function(response){
		$donateView.setDonateContent($routeParams.id);
		$donateView.manageView($scope, response);
		$dialogView.hideLoading();
	}
	
	$scope.$on("$destroy", function(){
       $store.off();
    });
	
	$donateLang.setLang($scope);

	$scope.setHeight = function(){
		return $donateView.setHeight();
	}

	$donateView.initParams();

	$navView.designateBut("donateTab");

	$scope.init();
}]);

controllers.controller("mainCtrl", ["$scope", "$routeParams", "$rootScope", "$manager", "$auth", "$mainView", "$dialogView", "$navView", "$mainLang", "$demon", "$way", "$adView",
						function($scope, $routeParams, $rootScope, $manager, $auth, $mainView, $dialogView, $navView, $mainLang, $demon, $way, $adView){
	$way.step($scope, "/main");
	$rootScope.locationTitle = $manager.instance.getUser().getNick();
	
	//user actions
	$scope.update = function(){
		$auth.update($scope);
	}
	
	$scope.response = function(response){
		$mainView.manageView($scope, response);
	}
	
	$scope.likeBid = function(answer){
		$dialogView.showDialogBidLikes(answer.getId());
	}
	
	$scope.$on("$destroy", function(){
		$mainView.removeScrollListener();
    });

    $scope.setHeight = function(){
		return $mainView.setHeight();
	}

	$scope.setMainImages = function(index){
		$mainView.setMainImages(index);
	}

	$mainView.setGuideVideo();
	
	$mainLang.setLang($scope);
	
	$demon.startNewsDemon();

	$mainView.initParams();
	
	if($manager.instance.getUser().isFirstTime()){
		$manager.instance.getDataManager().setSetting(Constant.FIRSTTIME_SETTING, 0, function(){
			$mainView.setGuideFirst();
		});
	}
	
	$navView.designateBut("mainTab");

	//initial state
	$mainView.setInfo($scope, $manager.instance.getUser());
	$mainView.initSwipe();
	$adView.init();
}]);

controllers.controller("tasksCtrl", ["$scope", "$routeParams", "$rootScope", "$action", "$tasksView", "$navView", "$tasksLang", "$dialogView", "$way",
						function($scope, $routeParams, $rootScope, $action, $tasksView, $navView, $tasksLang, $dialogView, $way){
	$rootScope.locationTitle = $dialogView.strings.tasksTitle;
	$way.step($scope, "/tasks");
	//delete task
	$scope.deleteTask = function(task){
		$action.deleteTask($scope, task);
	}
	
	$scope.response = function(response){
		$dialogView.hideLoading();
		$tasksView.manageView($scope, response);
	}
	
	$scope.tasks = function(){
		$dialogView.showLoading();
		$action.tasks($scope);
	}
	
	$scope.setHeight = function(){
		return $tasksView.setHeight();
	}

	$scope.setBgHeight = function(index){
		return $tasksView.setBgHeight(index);
	}

	$scope.setTasksImages = function(index){
		$tasksView.setTasksImages(index);
	}

	$tasksView.initParams();

	$navView.designateBut("tasksTab");

	//initial state
	$tasksLang.setLang($scope);
	$tasksView.initSwipe(); // order is
	$scope.tasks();			// important
	
	$scope.$on("$destroy", function() {
		$tasksView.initSwipeOk = false;
		$tasksView.removeScrollListener();
    });
}]);

controllers.controller("earnCtrl", ["$scope", "$rootScope", "$action", "$location", "$earnView", "$earnLang", "$manager", "$dialogView", "$navView", "$way",
						function($scope, $rootScope, $action, $location, $earnView, $earnLang, $manager, $dialogView, $navView, $way){
	$rootScope.locationTitle = $dialogView.strings.earnTitle;
	$way.step($scope, "/earn");
	$rootScope.earned = $manager.instance.getBot().getEarned();

	var isStart = $manager.instance.getBot().isRunnable();
	
	$scope.run = function(){
		if(!isStart){
			isStart = true;
			$earnView.hideHint(); // hide hints
			$action.run($scope);
		}
	}
	
	$scope.stop = function(){
		if(isStart){
			isStart = false;
			$action.stop($scope);
		}
	}
	
	$scope.response = function(response){
		$earnView.manageView($scope, response);
	}

	if(!isStart)
		$earnView.showHint(); // show hints

	$scope.setHeight = function(){
		return $earnView.setHeight();
	}

	$earnView.initParams();

	$navView.clearButtons();
	$earnView.centerEarnAnim(isStart);

	$earnLang.setLang($scope);
}]);

controllers.controller("bidLikeCtrl", ["$scope", "$routeParams", "$rootScope", "$manager", "$action", "$correct", "$bidLikeView", "$navView", "$mainView", "$dialogView", "$bidLang", "$way",
						function($scope, $routeParams, $rootScope, $manager, $action, $correct, $bidLikeView, $navView, $mainView, $dialogView, $bidLang, $way){
	$rootScope.locationTitle = $dialogView.strings.bidLikesTitle;
	$way.step($scope, "/bid_like");
	$scope.type = Constant.LIKE_TYPE;
	$scope.targetCount = Constant.LIKE_MIN_BID;
	$scope.price = "";
	
	$scope.bid = function(){
		/*var status = $correct.checkCorrect('like', $scope.link, $scope.targetCount);
		$bidLikeView.setButAnim(true);

		if(status.status == Constant.OK_STATUS){*/
			$action.bid($scope, new Bid($scope.link, $scope.targetCount, $scope.type));
		/*}else if(status.status == Constant.ERR_STATUS){
			$bidLikeView.setButAnim(false);
			$dialogView.showToast(status.message);
		}*/
	}
	
	$scope.response = function(response){
		$bidLikeView.manageView($scope, response);
	}
	
	$scope.changePrice = function(){
		if($scope.targetCount >= 0 && $scope.targetCount != '')
			$bidLikeView.setPrice($scope, $scope.targetCount * Constant.LIKE_PRICE, 1);
		else
			$bidLikeView.setPrice($scope, $scope.targetCount * Constant.LIKE_PRICE, 2);
	}

	//переключатель на странице лайков
	$scope.switcherLikes = function(num){
		$bidLikeView.switcherLikes($scope, num);
	}

	$scope.likeBid = function(video){
		$dialogView.showDialogBidLikes(video.getId());
	}
	
	$scope.setVideos = function(){
		$bidLikeView.setVideos($scope);
	}
	
	$scope.setHeight = function(){
		return $bidLikeView.setHeight();
	}

	$scope.setMainImages = function(index){
		$mainView.setMainImages(index);
	}

	$bidLikeView.initParams();
	
	$navView.designateBut("likeTab");
	
	$scope.setVideos();
	$bidLang.setLang($scope);
}]);

controllers.controller("bidSubsCtrl", ["$scope", "$routeParams", "$rootScope", "$manager", "$action", "$correct", "$bidSubsView", "$navView", "$dialogView", "$bidLang", "$manager", "$way",
						function($scope, $routeParams, $rootScope, $manager, $action, $correct, $bidSubsView, $navView, $dialogView, $bidLang, $manager, $way){
	$rootScope.locationTitle = $dialogView.strings.bidSubsTitle;
	$way.step($scope, "/bid_subs");
	var numPanel = 1;				// what content is visible now(1 - bid on acc, 2 - bid by link)
	$scope.type = Constant.SUBSCRIBE_TYPE;
	$scope.link = Constant.HOME_PAGE + $manager.instance.getUser().getChannel();
	$scope.targetCountAcc = Constant.SUBSCRIBE_MIN_BID;
	$scope.targetCountLink = Constant.SUBSCRIBE_MIN_BID;
	$scope.priceAcc = "";
	$scope.priceLink = "";
	
	$scope.bid = function(){
		var status = null;

		/*if(numPanel == 1)
			status = $correct.checkCorrect('subs', $scope.link, $scope.targetCountAcc);
		else
			status = $correct.checkCorrect('subs', $scope.link, $scope.targetCountLink);
		*/
		$bidSubsView.setButAnim(numPanel, true);

		//if(status.status == Constant.OK_STATUS){
			if(numPanel == 1){
				$action.bid($scope, new Bid($scope.link, $scope.targetCountAcc, $scope.type));
			}else{
				$action.bid($scope, new Bid($scope.link, $scope.targetCountLink, $scope.type));
			}
		/*}else if(status.status == Constant.ERR_STATUS){
			$bidSubsView.setButAnim();
			$dialogView.showToast(status.message);
		}*/
	}
	
	$scope.changePrice = function(){
		if(numPanel == 1){
			if($scope.targetCountAcc >= 0 && $scope.targetCountAcc != '')
				$bidSubsView.setPrice($scope, $scope.targetCountAcc * Constant.SUBSCRIBE_PRICE, 1);
			else
				$bidSubsView.setPrice($scope, $scope.targetCountAcc * Constant.SUBSCRIBE_PRICE, 3);
		}else{
			if($scope.targetCountLink >= 0 && $scope.targetCountLink != '')
				$bidSubsView.setPrice($scope, $scope.targetCountLink * Constant.SUBSCRIBE_PRICE, 2);
			else
				$bidSubsView.setPrice($scope, $scope.targetCountLink * Constant.SUBSCRIBE_PRICE, 3);
		}
	}
	
	$scope.response = function(response){
		$bidSubsView.manageView($scope, response);
	}

	$scope.acceptSubscribe = function(){
		$bidSubsView.acceptSubscribe();
	}

	//переключатель на странице подписчиков
	$scope.switcherSubs = function(num){
		numPanel = num;
		$bidSubsView.switcherSubs(num);
		if(num == 1)
			$scope.link = Constant.HOME_PAGE + $manager.instance.getUser().getNick();
	}
	
	$scope.setHeight = function(){
		return $bidSubsView.setHeight();
	}

	$bidSubsView.initParams();
	
	$navView.designateBut("likeTab");
	
	$bidLang.setLang($scope);
}]);


controllers.controller("navCtrl", ["$scope", "$routeParams", "$rootScope", "$auth", "$navView", "$adView", 
						function($scope, $routeParams, $rootScope, $auth, $navView, $adView){
	
	$scope.navClick = function(){
		$adView.showAd();
	}
}]);


controllers.controller("settingsCtrl", ["$scope", "$routeParams", "$rootScope", "$window", "$auth", "$settingsView", "$settingsLang", "$dialogView", "$navView", "$way", "$action",
						function($scope, $routeParams, $rootScope, $window, $auth, $settingsView, $settingsLang, $dialogView, $navView, $way, $action){
	$way.step($scope, "/settings");
	$scope.response = function(response){
		$settingsView.manageView($scope, response);
		setTimeout(function(){
			$dialogView.hideLoading();
		}, 500);
	}
	
	$scope.logout = function(){
		$navView.clearButtons();
		$dialogView.showLoading();
		$auth.logout($scope);
	}

	$scope.backFromSettings = function(){
		$way.goBack($scope);
	}

	$scope.sendMail = function(){
		$settingsView.sendMail($window);
	}

	$scope.watchGuide = function(){
		$settingsView.watchGuide();
	}

	$scope.seePrivacy = function(){
		$settingsView.seePrivacy($window);
	}

	$scope.setLinkOnApp = function(appId){
		$settingsView.setLinkOnApp(appId);
	}

	$scope.setImageOnApp = function(num){
		$settingsView.setImageOnApp(num);
	}

	$settingsView.initParams();

	$settingsLang.setLang($scope);
	$action.version($scope);
	$action.apps($scope);
}]);


controllers.controller("authtroubleCtrl", ["$scope", "$routeParams", "$rootScope", "$window", "$authTroubleView", "$authTroubleLang", "$way",
						function($scope, $routeParams, $rootScope, $window, $authTroubleView, $authTroubleLang, $way){
	$way.step($scope, "/authtrouble");
	
	$scope.backFromAuthTrouble = function(){
		$way.goBack($scope);
	}

	$scope.feedBackUs = function(){
		$authTroubleView.feedBackUs($window);
	}

	$authTroubleView.initParams();

	$authTroubleLang.setLang($scope);
}]);


controllers.controller("topCtrl", ["$scope", "$routeParams", "$rootScope", "$topView", "$topLang", "$action", "$dialogView", "$way",
						function($scope, $routeParams, $rootScope, $topView, $topLang, $action, $dialogView, $way){
	$topView.clearTimer();
	$way.step($scope, "/top");
	
	$scope.backFromTop = function(){
		$way.goBack($scope);
	}
	
	$scope.response = function(response){
		$topView.manageView($scope, response);
		setTimeout(function(){
			$dialogView.hideLoading();
		}, 500);
	}
	
	$scope.showHelpDialog = function(){
		$topView.showHelpDialog();
	}
	
	$scope.hideHelpDialog = function(){
		$topView.hideHelpDialog();
	}

	$topView.initParams();

	$dialogView.showLoading();
	$action.top($scope);

	$topLang.setLang($scope);
}]);


controllers.controller("lvlPrizeCtrl", ["$scope", "$routeParams", "$rootScope", "$lvlPrizeView", "$lvlPrizeLang", "$way",
						function($scope, $routeParams, $rootScope, $lvlPrizeView, $lvlPrizeLang, $way){
	
	$way.step($scope, "/lvlprize");

	$scope.backFromLvlPrize = function(){
		$way.goBack($scope);
	}

	$lvlPrizeView.initParams();
	
	$lvlPrizeLang.setLang($scope);
	$lvlPrizeView.setItems($scope);
}]);


controllers.controller("guideCtrl", ["$scope", "$routeParams", "$rootScope", "$mainView", "$guideView", "$guideLang",
						function($scope, $routeParams, $rootScope, $mainView, $guideView, $guideLang){
	
	$scope.setGuideImages = function(){
		$guideView.setGuideImages();
	}

	$guideView.setActionClick($mainView);

	$guideLang.setLang($scope);
}]);


controllers.controller("mineAdCtrl", ["$scope", "$routeParams", "$rootScope", "$window", "$mineAdView", "$mineAdLang",
						function($scope, $routeParams, $rootScope, $window, $mineAdView, $mineAdLang){

	$scope.handleAd = function(num){
		$mineAdView.handleAd($window, num);
	}
	
	$mineAdLang.setLang($scope);
}]);

controllers.controller("privacyCtrl", ["$scope", "$routeParams", "$rootScope", "$privacyView", "$privacyLang", "$way",
						function($scope, $routeParams, $rootScope, $privacyView, $privacyLang, $way){
	$way.step($scope, "/privacy");
	
	$scope.backPrivacy = function(){
		$way.goBack($scope);
	}

	$privacyView.initParams();

	$privacyLang.setLang($scope);
}]);

