var filters = angular.module("famousFilters", []);

filters.filter("prepareHtml", ['$sce', function($sce){
	return function(htmlCode){
		return $sce.trustAsHtml(htmlCode);
	}
}]);

filters.filter('placeColors', function(){
    return function (num){
    	switch(num){
    		case 1:
				return "border: 2px solid #00AC35; color: #00AC35;";
			case 2:
				return "border: 2px solid #FF862D; color: #FF862D;";
			case 3:
				return "border: 2px solid #DD3131; color: #DD3131;";
			case 4:
				return "border: 2px solid #1FA6B6; color: #1FA6B6;";
			case 5:
				return "border: 2px solid #6A80F0; color: #6A80F0;";
			default:
				return "border: 2px solid transparent;";
    	}
    	return "";
    };
});

filters.filter("putVideosImage", function(){
	return function(index){
		if(index % 3 == 0){
			return "float: left;";
		}else if(index % 3 == 2){
			return "float: right;";
		}else{
			return "float: left; margin-left: 2%;";
		}
	}
});

filters.filter("taskType", function(){
	return function(type, scope){
		if(type == Constant.LIKE_TYPE)
			return scope.likesText;
		else if(type == Constant.SUBSCRIBE_TYPE)
			return scope.followersText;
		else
			return "";
	}
});

filters.filter("reNum", function(){
	return function(str){
		var num = parseInt(str);
		var res;
		var numStr = num + "";
		if(num >= 1000 && num < 10000){
			res = numStr.substring(0, 1) + "." + numStr.substring(1, 2) + "K";
			return res;
		}else if(num >= 10000 && num < 100000){
			res = numStr.substring(0, 2) + "." + numStr.substring(2, 3) + "K";
			return res;
		}else if(num >= 100000 && num < 1000000){
			res = numStr.substring(0, 3) + "." + numStr.substring(3, 4) + "K";
			return res;
		}else if(num >= 1000000 && num < 10000000){
			res = numStr.substring(0, 1) + "." + numStr.substring(1, 2) + "M";
			return res;
		}else if(num >= 10000000 && num < 100000000){
			res = numStr.substring(0, 2) + "." + numStr.substring(2, 3) + "M";
			return res;
		}else{
			return num;
		}
	}
});