var services = angular.module("famousServices", []);

services.service("$manager", ["$rootScope", function($rootScope){
	this.instance = new Manager($rootScope);
}]);

services.service("$action",["$manager", "$demon", "$saver", function($manager, $demon, $saver){
	var self = this;
	this.bid = function($scope, bid){
		$manager.instance.getBrowser().getMetaHead(bid, function(dataBrowser){		//check page for valid
			if(dataBrowser != null && dataBrowser.status == Constant.OK_STATUS){
				bid.setMeta(dataBrowser.metaHead.meta);
				bid.setHead(dataBrowser.metaHead.head);
				$manager.instance.getConnector().bid(bid, function(result){	//try to add
					if(result.status == Constant.OK_STATUS){
						$saver.clear("tasks");
						$manager.instance.getUser().setCash(result.cash);
						$scope.response({action: "bid", status:Constant.OK_STATUS, data: {cash: result.cash}});
					}else if(result.status == Constant.ERR_CODE_CONNECTOR_CONNECTION){
						$scope.response({action: "bid", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
					}else{
						$scope.response({action: "bid", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_BID}});
					}
				});
			}else{
				$scope.response({action: "bid", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_BROWSER_BID}});
			}
		});
	}
	
	this.tasks = function($scope){
		var saverStat = $saver.load("tasks");
		if(saverStat.status == Constant.OK_STATUS){
			$scope.response({action: "tasks", status:Constant.OK_STATUS, data: saverStat.data});
		}else{
			$manager.instance.getConnector().getTasks(function(dataConnector){
				if(dataConnector.status == Constant.OK_STATUS){
					$saver.saveSpec("tasks", {tasks: dataConnector.tasks}, 5);
					$scope.response({action: "tasks", status:Constant.OK_STATUS, data: {tasks: dataConnector.tasks}});
				}else if(dataConnector.status == Constant.ERR_CODE_CONNECTOR_CONNECTION){
					$scope.response({action: "tasks", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
				}else{
					$scope.response({action: "tasks", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_TASKS}});
				}
			});
		}
	}
	
	this.version = function($scope){
		var saverStat = $saver.load("version");
		if(saverStat.status == Constant.OK_STATUS){
			$scope.response({action: "version", status:Constant.OK_STATUS, data: saverStat.data});
		}else{
			$manager.instance.getConnector().version(function(dataConnector){
				//only if ok status
				if(dataConnector.status == Constant.OK_STATUS){
					$saver.saveSpec("version", {version: dataConnector.version}, 3600);
					$scope.response({action: "version", status:Constant.OK_STATUS, data: {version: dataConnector.version}});
				}
			});
		}
	}
	
	this.apps = function($scope){
		var saverStat = $saver.load("apps");
		if(saverStat.status == Constant.OK_STATUS){
			$scope.response({action: "apps", status:Constant.OK_STATUS, data: saverStat.data});
		}else{
			$manager.instance.getConnector().apps(function(dataConnector){
				//only if ok status
				if(dataConnector.status == Constant.OK_STATUS){
					$saver.saveSpec("apps", {apps: dataConnector.apps}, 3600);
					$scope.response({action: "apps", status:Constant.OK_STATUS, data: {apps: dataConnector.apps}});
				}
			});
		}
	}
	
	this.top = function($scope){
		var saverStat = $saver.load("top");
		if(saverStat.status == Constant.OK_STATUS){
			$scope.response({action: "top", status:Constant.OK_STATUS, data: saverStat.data});
		}else{
			$manager.instance.getConnector().getTop(function(dataConnector){
				if(dataConnector.status == Constant.OK_STATUS){
					$saver.saveSpec("top", dataConnector, 60);
					$scope.response({action: "top", status:Constant.OK_STATUS, data: dataConnector});
				}else if(dataConnector.status == Constant.ERR_CODE_CONNECTOR_CONNECTION){
					$scope.response({action: "top", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
				}else{
					$scope.response({action: "top", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_TOP}});
				}
			});
		}
	}
	
	this.news = function($scope){
		var saverStat = $saver.load("news");
		if(saverStat.status == Constant.OK_STATUS){
			$scope.response({action: "news", status:Constant.OK_STATUS, data: saverStat.data});
		}else{
			$manager.instance.getConnector().watchAllNews(function(response){
				if(response.status == Constant.OK_STATUS){
					$manager.instance.getConnector().getNews(function(dataConnector){
						if(dataConnector.status == Constant.OK_STATUS){
							$saver.saveSpec("news", {news: dataConnector.news}, 60);
							$scope.response({action: "news", status:Constant.OK_STATUS, data: {news: dataConnector.news}});
						}else if(dataConnector.status == Constant.ERR_CODE_CONNECTOR_CONNECTION){
							$scope.response({action: "news", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
						}else{
							$scope.response({action: "news", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_NEWS}});
						}
					});
				}else if(response.status == Constant.ERR_CODE_CONNECTOR_CONNECTION){
					$scope.response({action: "news", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
				}
				else{
					$scope.response({action: "news", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_NEWS}});
				}
			});
		}
	}
	
	this.complite = function(name, id, message, value, $scope){
		$manager.instance.getConnector().setComplite(name, id, value, function(dataConnector){
			if(dataConnector.status == Constant.OK_STATUS){
				$saver.clear("news");
				$scope.response({action: "complite", status:Constant.OK_STATUS, data: {cash: dataConnector.cash, name: name, message: message}});
			}else if(dataConnector.status == Constant.ERR_CODE_CONNECTOR_CONNECTION){
				$scope.response({action: "complite", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
			}else{
				$scope.response({action: "complite", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_COMPLITE}});
			}
		});
	}
	
	this.run = function($scope){
		$manager.instance.getBot().run(function(result){
			if(result == Constant.OK_STATUS){
				$scope.response({action: "run", status:Constant.OK_STATUS, data: {}});
			}else{
				$scope.response({action: "run", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_BOT_RUN}});
			}
		});
	}
	
	this.stop = function($scope){
		$manager.instance.getBot().stop(function(result){
			if(result == Constant.OK_STATUS){
				$scope.response({action: "stop", status:Constant.OK_STATUS, data: {}});
			}else{
				$scope.response({action: "stop", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_BOT_STOP}});
			}
		});
	}
	
	this.deleteTask = function($scope, task){
		$manager.instance.getConnector().deleteTask(task.getId(), task.getType(), function(result){
			if(result.status == Constant.OK_STATUS){
				$saver.clear("tasks");
				$manager.instance.getUser().setCash(result.cash);
				$scope.response({action: "delete", status:Constant.OK_STATUS, data: {task:task, cash: result.cash}});
			}else if(result.status == Constant.ERR_CODE_CONNECTOR_CONNECTION){
				$scope.response({action: "delete", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
			}else{
				$scope.response({action: "delete", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_DELETE}});
			}
		});
	}
}]);

services.service("$auth",["$manager", "$dialogView", "$demon", "$way", "$saver", function($manager, $dialogView, $demon, $way, $saver){
	var self = this;
	this.load = function($scope){

		$manager.instance.getDataManager().loadAuthData(function(dataManager){				//try to load login data from files
			if(dataManager.status == Constant.OK_STATUS){									//we found something
			}else{
				$scope.response({action: "load", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_DATA_LOAD}});
			}
		});
	}
	
	this.auth = function($scope){							//login scope
		tryAuth($scope, $manager);
	}
	
	var tryAuth = function($scope, $manager){
		$manager.instance.getBrowser().auth(function(result){			//try auth with login data
			if(result == Constant.OK_STATUS){								//auth good
				self.getInfo($scope);
			}else if(result == Constant.ERR_CODE_BROWSER_REINIT){
				$dialogView.showLoading();
				$manager.instance.getBrowser().init(function(response){
					tryAuth($scope, $manager);
				});
			}else if(result == Constant.ERR_CODE_BROWSER_CLOSED){
				$manager.instance.getBrowser().init(function(response){
					if(response == Constant.OK_STATUS_IN){
						self.getInfo($scope);
					}else{
						$dialogView.hideLoading();
					}
				});
			}else if(response == Constant.ERR_STATUS){
				$scope.response({action: "auth", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
			}
		});
	}
	
	this.preload = function($scope){
		var sel = this;
		$manager.instance.getBrowser().init(function(response){
			$dialogView.hideLoadingStart();
			$dialogView.showLoading();
			if(response == Constant.OK_STATUS_IN){
				self.getInfo($scope);
			}else if(response == Constant.OK_STATUS){
				$dialogView.hideLoading();
			}else if(response == Constant.ERR_STATUS){
				$scope.response({action: "auth", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
			}
			
		});
	}
	
	this.getInfo = function($scope){
		$manager.instance.getBrowser().getUserInfo(function(dataBrowser){	//get UserInfo
			if(dataBrowser != null){
				$manager.instance.getUser().setUserInfo(dataBrowser.userInfo);	//set user info
				$manager.instance.getDataManager().loadAuthData(function(dataManager){				//try to load login data from files
					
					var authData = new AuthData(dataBrowser.userInfo.email, "", 0);
					
					if(dataManager.status == Constant.OK_STATUS){									//we found something
						//if logins not equal
						if(authData.getLogin() != dataManager.authData.getLogin()){
							authData.setOldLogin(dataManager.authData.getLogin());
							authData.setNeedUpdate(1);
						}
					}
					
					$manager.instance.getUser().setAuthData(authData);
					
					$manager.instance.getConnector().auth(function(dataConnector){	//connect to server and get valid token
						if(dataConnector.status == Constant.OK_STATUS){
							var user = $manager.instance.getUser();
							user.setCash(dataConnector.cash);	//set new data
							user.setXpInfo(dataConnector.xp_info);
							$way.refresh();
							user.setPremium(dataConnector.premium);
							user.setTurbo(dataConnector.turbo);
							user.setRtime(dataConnector.rtime);
							user.setAchieves(dataConnector.achieves);
							user.setId(dataConnector.id);
							$manager.instance.getDataManager().saveAuthData(authData, function(saveManager){			//save to storage
								if(saveManager.status == Constant.OK_STATUS){
									
									var val = $manager.instance.getUser().getSetting(Constant.AUTOEARN_SETTING) == 1 ? true : false;
									//run bot if setting is ON and user come not first time
									if(val && !$manager.instance.getUser().isFirstTime()){
										$manager.instance.getBot().run(function(result){
											
										});
									}
									$demon.startPayDemon();
				
									$scope.response({action: "auth", status:Constant.OK_STATUS, data: {}});
								}else{
									$scope.response({action: "auth", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_DATA_SAVE}});
								}
							});
						}else if(dataConnector.status == Constant.ERR_CODE_CONNECTOR_CONNECTION){
							$scope.response({action: "auth", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
						}else{
							$scope.response({action: "auth", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_AUTH}});
						}
					});
				
					
				});
			}else{
				$scope.response({action: "auth", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_BROWSER_INFO}});
			}
		});
	}
	
	this.update = function($scope){						//Main scope
		var saverStat = $saver.load("update");
		if(saverStat.status == Constant.OK_STATUS){
			$scope.response({action: "update", status:Constant.OK_STATUS, data: saverStat.data});
		}else{
			$manager.instance.getBrowser().update(function(dataBrowser){	//update browser
				if(dataBrowser != null){
					$manager.instance.getUser().setUserInfo(dataBrowser.userInfo);
					$manager.instance.getConnector().update(function(dataConnector){	//update connector
						if(dataConnector.status == Constant.OK_STATUS){
							$manager.instance.getUser().setAuthData(dataConnector.authData);
							$manager.instance.getUser().setCash(dataConnector.cash);
							$manager.instance.getUser().setAchieves(dataConnector.achieves);
							$manager.instance.getUser().setXpInfo(dataConnector.xp_info);
							$saver.saveSpec("update", {}, 5);
							$scope.response({action: "update", status:Constant.OK_STATUS, data: {}});
						}else if(dataConnector.status == Constant.ERR_CODE_CONNECTOR_CONNECTION){
							$scope.response({action: "update", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
						}else{
							$scope.response({action: "update", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_UPDATE}});
						}
					});
				}else{
					$scope.response({action: "update", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_BROWSER_UPDATE}});
				}
			});
		}
	}
	
	this.logout = function($scope){
		$manager.instance.getBot().stop(function(response){
			;//response
		});
		$manager.instance.getBrowser().logout(function(resultBrowser){				//logout from browser
			if(resultBrowser == Constant.OK_STATUS){
				$manager.instance.getConnector().logout(function(resultConnector){	//logout from connector
					if(resultConnector.status == Constant.OK_STATUS){
						$manager.instance.getDataManager().clearAuthData(function(resultManager){		//clear data
							if(resultManager.status == Constant.OK_STATUS){
								$manager.instance.getUser().reset();		//reset user
								$scope.response({action: "logout", status:Constant.OK_STATUS, data: {}});
							}else{
								$scope.response({action: "logout", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_DATA_CLEAR}});
							}
						});
					}else if(resultConnector.status == Constant.ERR_CODE_CONNECTOR_CONNECTION){
						$scope.response({action: "logout", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
					}else{
						$scope.response({action: "logout", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_LOGOUT}});
					}
				});
			}else{
				$scope.response({action: "logout", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_BROWSER_LOGOUT}});
			}
		});
	}
}]);

services.service("$lang", ["$manager", function($manager){
	var self = this;
	this.locale = "";
	this.list = new Array();
	
	var setLocale = function(locale){
		var locale = locale.value.split("-");
		self.locale = locale[0];		//need parse
		$manager.instance.getUser().setLang(self.locale);
		self.setLangs();
	}
	
	this.getLang = function(view, callback){
		this.list.push({view: view, callback: callback});
		if(self.locale != ""){
			self.setLangs();
		}
	}
	
	this.setLangs = function(){
		while(self.list.length > 0){
			var entity = self.list.shift();
			var lang = null;
			switch(self.locale){
				case Constant.EN_LANG:
					lang = Lang.getLang(Constant.EN_LANG, entity.view);
					break;
				case Constant.UA_LANG:
				case Constant.BE_LANG:
				case Constant.RU_LANG:
					lang = Lang.getLang(Constant.RU_LANG, entity.view);
					break;
				default:		//Constant.EN_LANG
					lang = Lang.getLang(Constant.EN_LANG, entity.view);
					break;
			}
			entity.callback(lang);
		}
	}
	
	this.getLocale = function(){
		if(this.locale != Constant.RU_LANG)
			return Constant.EN_LANG;
		return this.locale;
	}
	
	this.getRealLocale = function(){
		return this.locale;
	}
	
	navigator.globalization.getLocaleName(function(locale) {
		setLocale(locale);
	}, function(){
		setLocale("en-US");
	});
}]);


services.service("$correct", ["$manager", "$lang", function($manager, $lang){

	var self = this;
	this.strings = {};
	
	this.checkCorrect = function(type, link, count){
		var status = {status: "", message: ""};

		switch(type){
			case 'like':
				status = likeLinkCheck(type, link, count);
				break;
			case 'subs':
				status = subsLinkCheck(type, link, count);
				break;
			default:
				break;
		}
		return status;
	}

	var likeLinkCheck = function(type, url, count){
		if(url){																							// if input exist
			if(url != ''){																					// if input isn't empty
				if(url.indexOf(Constant.YT_HOST) != -1 || url.indexOf(Constant.YU_HOST_DESKTOP) != -1){		// if input has 'ask.fm' and 'answer'
					//if(url.indexOf('http') != -1)
					//	url = url + 'http://';
					return moneyCheck(count, type);
				}else{
					return {status: Constant.ERR_STATUS, message: self.strings.enterLink};
				}
			}else{
				return {status: Constant.ERR_STATUS, message: self.strings.emptyLink};
			}
		}else{
			return {status: Constant.ERR_STATUS, message: self.strings.notExistLink};
		}
	}

	var subsLinkCheck = function(type, url, count){
		if(url){																							// if input exist
			if(url != ''){																					// if input isn't empty
				if(url.indexOf(Constant.YT_HOST) != -1 || url.indexOf(Constant.YU_HOST_DESKTOP) != -1){		// if input has 'ask.fm'
					//if(url.indexOf('http') != -1)
					//	url = url + 'http://';
					return moneyCheck(count, type);
				}else{
					return {status: Constant.ERR_STATUS, message: self.strings.enterLink};
				}
			}else{
				return {status: Constant.ERR_STATUS, message: self.strings.emptyLink};
			}
		}else{
			return {status: Constant.ERR_STATUS, message: self.strings.notExistLink};
		}
	}

	var moneyCheck = function(num, type){

		var factor = 0;
		if(type == 'like')
			factor = Constant.LIKE_PRICE;
		else if(type == 'subs')
			factor = Constant.SUBSCRIBE_PRICE;

		if(isNumeric(num)){																				// if number is numeric
			if(num > 0){																				// if number more than 0
				if(num * factor <= $manager.instance.getUser().getCash().getFreeSum()){					// if number less than user has cash
					if($manager.instance.getUser().getPremium()){										// if user has premium acc
						if($manager.instance.getUser().getTurbo() != 3){								// if user has turbo 3
							if(type == 'like'){															// if input type is 'like'
								if(num <= Constant.MAX_PREM_COUNT_LIKE){								// if prem number between likes min and max
									return {status: Constant.OK_STATUS, message: ""};
								}else{
									return {status: Constant.ERR_STATUS, message: self.strings.minMaxPremLikes};
								}
							}else{
								if(num <= Constant.MAX_PREM_COUNT_SUBS){								// if prem number between subs min and max
									return {status: Constant.OK_STATUS, message: ""};
								}else{
									return {status: Constant.ERR_STATUS, message: self.strings.minMaxPremSubs};
								}
							}
						}else{
							return {status: Constant.OK_STATUS, message: ""};
						}
					}else{
						if($manager.instance.getUser().getTurbo() != 3){								// if user has turbo 3
							if(type == 'like'){
								if(num >= Constant.MIN_COUNT_LIKE && num <= Constant.MAX_COUNT_LIKE){	// if number between likes min and max
									return {status: Constant.OK_STATUS, message: ""};
								}else{
									return {status: Constant.ERR_STATUS, message: self.strings.minMaxLikes};
								}
							}else{
								if(num >= Constant.MIN_COUNT_SUBS && num <= Constant.MAX_COUNT_SUBS){	// if number between subs min and max
									return {status: Constant.OK_STATUS, message: ""};
								}else{
									return {status: Constant.ERR_STATUS, message: self.strings.minMaxSubs};
								}
							}
						}else{
							return {status: Constant.OK_STATUS, message: ""};
						}
					}
				}else{
					return {status: Constant.ERR_STATUS, message: self.strings.noCoins};
				}
			}else{
				return {status: Constant.ERR_STATUS, message: self.strings.errNegative};
			}
		}else{
			return {status: Constant.ERR_STATUS, message: self.strings.errNumber};
		}
	}

	function isNumeric(n){
		return !isNaN(parseFloat(n)) && isFinite(n);
	}
	
	$lang.getLang(Constant.CORRECT_VIEW, function(lang){
		self.strings = lang;
	});
}]);

services.service("$cssParser", function(){
	var self = this;
	
	this.parseCss = function(data){
		/*var ratio = 1;//getRatio();
		var css = "";
		data = data.replace("\t", "");
		data = data.replace("\r", "");
		var lines = data.split("\n");
		
		for(var i = 0; i < lines.length; i++){
			var pxs = lines[i].match(/(\d+)\s?px/ig);
			for(var index in pxs){
				var px = parseInt(pxs[index], 10);
				var newPx = Math.ceil((px * ratio));
				lines[i] = lines[i].replace(px+"px", newPx+"px");
			}
			css += lines[i];
		}*/
			
		return data;
	}
	
	var getRatio = function(){
		var targetRatio = window.devicePixelRatio;
		var curRatio = Constant.CUR_RATIO;
		
		return curRatio / targetRatio;
	}
});

services.service("$store", ["$donateView", "$dialogView", "$manager", function($donateView, $dialogView, $manager){
	
	var isInit = false;
	var actionDone = false;
	
	var products = new Array();
	
	this.init = function(callback){
		if (!window.store) {
			callback({action: "store", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_LOAD_STORE}});
		}
		
		if(!isInit){
			$dialogView.showLoading();
			isInit = true;
			actionDone = true;
			store.validator = Constant.VERIFY_URL;
		//	store.verbosity = store.QUIET;		//store.ERROR
			store.verbosity = store.DEBUG;
			
			this.register('pack_1', 'x1000', store.CONSUMABLE);							
			this.register('pack_2', 'x2000', store.CONSUMABLE);
			this.register('pack_3', 'x5000', store.CONSUMABLE);							
			this.register('pack_4', 'x10000', store.CONSUMABLE);						
			this.register('pack_5', 'x20000', store.CONSUMABLE);
			this.register('premium', $dialogView.strings.premiumText, store.CONSUMABLE);
			
			//if not have turbo_1
			if($manager.instance.getUser().getTurbo() != 1){
				this.register('turbos_1', 'Turbo green', store.PAID_SUBSCRIPTION);
				this.simpleUpdate("turbos_1");
				this.simpleApproved("turbos_1");
				this.simpleVerify("turbos_1");
				this.unVerify("turbos_1");
			}
			
			if($manager.instance.getUser().getTurbo() != 2){
				this.register('turbos_2', 'Turbo blue', store.PAID_SUBSCRIPTION);
				this.simpleUpdate("turbos_2");
				this.simpleApproved("turbos_2");
				this.simpleVerify("turbos_2");
				this.unVerify("turbos_2");
			}
			
			if($manager.instance.getUser().getTurbo() != 3){
				this.register('turbos_3', 'Turbo red', store.PAID_SUBSCRIPTION);
				this.simpleUpdate("turbos_3");
				this.simpleApproved("turbos_3");
				this.simpleVerify("turbos_3");
				this.unVerify("turbos_3");
			}
			this.simpleUpdate("pack_1");
			this.simpleUpdate("pack_2");
			this.simpleUpdate("pack_3");
			this.simpleUpdate("pack_4");
			this.simpleUpdate("pack_5");
			this.simpleUpdate("premium");
			
			this.simpleApproved("pack_1");
			this.simpleApproved("pack_2");
			this.simpleApproved("pack_3");
			this.simpleApproved("pack_4");
			this.simpleApproved("pack_5");
			this.simpleApproved("premium");
			
			this.simpleVerify("pack_1");
			this.simpleVerify("pack_2");
			this.simpleVerify("pack_3");
			this.simpleVerify("pack_4");
			this.simpleVerify("pack_5");
			this.simpleVerify("premium");
			
			
			this.unVerify("pack_1");
			this.unVerify("pack_2");
			this.unVerify("pack_3");
			this.unVerify("pack_4");
			this.unVerify("pack_5");
			this.unVerify("premium");
			
			
			var toid = setTimeout(function(){
				callback({action: "store", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_LOAD_STORE}});
			}, Constant.WAIT_STORE_TIME);

			store.ready(function() {
				clearTimeout(toid);
				callback({action: "store", status:Constant.OK_STATUS, data: {}});
			});
			
			store.error(function(error) {
				Log.o("STORE", error);
			});
			
			this.refresh();
		}else if(!actionDone){
			actionDone = true;
			$dialogView.showLoading();
			this.renderAll(callback);
		}
	
	}
	
	
	this.register = function(id, alias, type){
		store.register({
			id:    id, 			// id without package name!
			alias: alias,
			type:  type
		});
	}
	
	this.refresh = function(){
		store.refresh();
	}
	
	this.simpleUpdate = function(id){
		var self = this;
		store.when(id).updated(function (p) {
			self.render(p);
		});
	}
		
	this.simpleApproved = function(id){
		store.when(id).approved(function (order) {
			$dialogView.showToast($dialogView.strings.checkoutText);
			order.verify();
		});
	}
	
	this.unVerify = function(id){
		store.when(id).unverified(function (order) {
			$dialogView.showToast($dialogView.strings.verifyErr);
		});
	}
	
	this.simpleVerify = function(id){
		store.when(id).verified(function(order) {
			if(order.type == store.PAID_SUBSCRIPTION){
				$manager.instance.getConnector().subscribe(order.transaction.purchaseToken, function(response){
					if(response.status == Constant.ERR_CODE_CONNECTOR_CONNECTION){
						$dialogView.showToast($dialogView.strings.connectErr);
					}
					else if(response.status != Constant.OK_STATUS){
						$dialogView.showToast($dialogView.strings.donateBuyErr);
					}else{
						//setTurbo
						$manager.instance.getUser().setTurbo(response.turbo);
						$dialogView.showToast($dialogView.strings.donateBuyOk);
						order.finish();
					}
				});
			}else{
				$manager.instance.getConnector().purchase(order.transaction.purchaseToken, function(response){
					if(response.status == Constant.ERR_CODE_CONNECTOR_CONNECTION){
						$dialogView.showToast($dialogView.strings.connectErr);
					}
					else if(response.status != Constant.OK_STATUS){
						$dialogView.showToast($dialogView.strings.donateBuyErr);
					}else{
						$manager.instance.getUser().setCash(response.cash);	//set new data
						if(id == "premium")
							$manager.instance.getUser().setPremium(1);
						$manager.instance.setCash();
						$dialogView.showToast($dialogView.strings.donateBuyOk);
						order.finish();
					}
				});
			}
		});
	}	
	
	this.order = function(id){
		store.order(id);
	}
	
	this.render = function(p) {
		products.push(p);
		$donateView.render(p);
	};
	
	this.off = function(){
		actionDone = false;
	}
	
	this.renderAll = function(callback){
		for(var i in products){
			$donateView.render(products[i]);	
		}
		callback({action: "store", status:Constant.OK_STATUS, data: {}});
	}

}]);

services.service("$demon", ["$manager", "$navView", "$saver", function($manager, $navView, $saver){
	
	var newsId = -1;
	var payId = -1;
	
	var getPayTime = function(){
		var turbo = $manager.instance.getUser().getTurbo();
		var speeds = [1, 0.9, 0.8, 0.7, 0.9];
		var time = parseInt((Constant.PAY_DEMON_TIME * speeds[turbo]), 10);
		
		return time;
	}
	
	this.startNewsDemon = function(){
		if(newsId == -1){
			setTimeout(function(){
				checkNewsCount();
				newsId = setInterval(function(){
					if( newsId != -1){
						checkNewsCount();
					}
				}, Constant.NEWS_DEMON_TIME);
			}, 1000);
		}
	}
	
	this.stopNewsDemon = function(){
		clearInterval(newsId);
		newsId = -1;
	}
	
	this.startPayDemon = function(){
		var payDemonTime = getPayTime();
	
		if(payId == -1){
			setTimeout(function(){
				if($manager.instance.getBot().isRunnable())
					intervalPay();
				payId = setInterval(function(){
					if( payId != -1){
						if($manager.instance.getBot().isRunnable())
							intervalPay();
					}
				}, payDemonTime);
			}, 1000);
		}
	}
	
	this.stopPayDemon = function(){
		clearInterval(payId);
		payId = -1;
	}
	
	var intervalPay = function(){
		$manager.instance.getConnector().intervalPay(function(response){
			if(response.status == Constant.OK_STATUS){
				$manager.instance.getBot().paySum(response.sum);
			}else{
				//nothing to do here
			}
		});
	}
	
	var checkNewsCount = function(){
		$saver.clear("news");
		$manager.instance.getConnector().getNewsCount(function(response){
			if(response.status == Constant.OK_STATUS){
				$navView.setNewsCounter(parseInt(response.count, 10));
			}else{
				//nothing to do here
			}
		});
	}
}]);

services.service("$saver", function(){
	var datas = new Array();
	
	this.save = function(name, data){
		this.saveSpec(name, data, Constant.RELOAD_ACTION_TIME);
	}
	
	this.saveSpec = function(name, data, limit){
		var time = getTime();
		datas[name] = {data:data, time:time, limit:limit};
	}
	
	this.load = function(name){
		var timeNow = getTime();
		if(typeof datas[name] !== "undefined" && datas[name] != null){
			if((timeNow - datas[name].time ) <= datas[name].limit){
				return {status:Constant.OK_STATUS, data: datas[name].data};
			}else{
				datas[name] = null;
				return {status:Constant.ERR_STATUS}
			}
		}else{
			return {status:Constant.ERR_STATUS};
		}
	}
	
	this.clear = function(name){
		datas[name] = null;
	}
	
	var getTime = function(){
		var time = new Date().getTime() / 1000;
		time = parseInt(time, 10);
		return time;
	}
	
});

services.service("$way", ["$location", function($location){

	var self = this;
	var curScope;
	var lastBack;
	var way = new Array();
	
	this.step = function(scope, path){
		curScope = scope;
		if(lastBack != path)
			way.push(path);
	}
	
	this.back = function(){
		way.pop();
		if(way.length >= 1)
			return way[way.length - 1];
		else
			return "/";
	}
	
	this.goBack = function($scope){
		var path = this.back();
		lastBack = path;
		if(path != "/"){
			$location.path(path);
			$scope.$applyAsync();
		}
	}
	
	this.refresh = function(){
		way = new Array();
	}
	
	document.addEventListener("backbutton", function(){
		self.goBack(curScope);
	}, false);
}]);

services.service("$adLoader", ["$manager", function($manager){

	var curAd;
	var self = this;
	var ads = new Array();
	var adView;
	
	this.prepare = function(av, a){
		adView = av;
		ads = a;
		this.prepareNext();
	}
	
	this.prepareNext = function(){
		if(ads.length > 0){
			curAd = ads.shift();
			setImages(function(){
				adView.loaded();
			});
		}else{
			adView.setMode(Constant.AD_MOB_MODE);
			adView.prepareAdMob();
		}
	}
	
	this.show = function(){
		$(".minead-middle-head:first").text(curAd.getAppName());
		$(".minead-middle-rate-text:first").text("(" + Math.round(2 + Math.random() * (9 - 2)) + "," + Math.round(100 + Math.random() * (999 - 100)) + ")");
		$(".minead-middle-text1:first").text(curAd.getDesc1());
		$(".minead-middle-text2:first").text(curAd.getDesc2());
		
		$(".minead-block:first").removeClass("none");
	}

	this.dismiss = function(windowObj, num){
		if(num == 0){
			$(".minead-block:first").addClass("none");
		}else{
			navigator.app.loadUrl("https://play.google.com/store/apps/details?id=" + curAd.getAppId(), {openExternal : true});
		}
		curAd.setStatus(num);
		$manager.instance.getConnector().viewAd(curAd, function(){
			$(".minead-block:first").addClass("none");
			adView.dismiss();
		});
	}

	function setImages(callback){
		$('.minead-top-background:first').attr('src', Constant.SERVER_HOST + "images/apps/" + curAd.getName() + "_header.png").load(function(){
			$('.minead-top-logo:first').attr('src', Constant.SERVER_HOST + "images/apps/" + curAd.getName() + "_icon.png").load(function(){
				callback();
			});
		});
	}
	
}]);

services.service("$tracker", ["$manager", function($manager){
	window.onerror = function(message, url, lineNumber) {
		Log.e(url + " " + lineNumber, message);
		$manager.instance.getConnector().error(message, (url + " " + lineNumber), function(){});
		return true; 
	};
}]);