var services_views = angular.module("famousServicesViews", []);

services_views.service("$dialogView", ["$rootScope", "$manager", "$lang", function($rootScope, $manager, $lang){
	var self = this;
	this.strings = {};
	
	this.manageView = function($scope, response){
		if(response.status == Constant.OK_STATUS){
			this.okView($scope, response);
		}else{
			this.errView($scope, response);
		}
		$scope.$applyAsync();
	}
	
	this.okView = function($scope, response){
		switch(response.action){
			case "bid":
				this.bidOk($scope, response);
				break;
		}
	}
	
	this.errView = function($scope, response){
		switch(response.action){
			case "bid":
				this.bidErr($scope, response);
				break;
		}
	}
	
	this.bidOk = function($scope, response){
		animSend(false);
		this.showToast(this.strings.bidOk);
		this.hideDialogBidLikes();
		this.setCash(response.data.cash);

		//$scope.targetCountDialog = 0;
		//$scope.applyAsync();
	}
	
	this.setCash = function(cash){
		$rootScope.freeSum = cash.getFreeSum();
	}
	
	this.bidErr = function($scope, response){
		animSend(false);
		switch(response.data.errorCode){
			case Constant.ERR_CODE_CONNECTOR_BID:
				this.showToast(this.strings.bidFail);
				break;
			case Constant.ERR_CODE_BROWSER_BID:
				this.showToast(this.strings.mhFail);
				break;
			case Constant.ERR_CODE_CONNECTOR_CONNECTION:
				this.showToast(this.strings.connectErr);
				break;
		}
	}

	this.setPrice = function($scope, price, num){
		if(num == 1)
			$scope.price = price;
		else
			$scope.price = "";
	}

	// show preloading
	this.showLoadingStart = function(){
		$('.init-logo').removeClass("none");
	}
	
	// hide preloading
	this.hideLoadingStart = function(){
		$('.init-block').addClass("none");
	}

	// run loading
	this.showLoading = function(){
		actFogging('loading-block', true);
		$('.loading-block').removeClass('none');
	}

	// stop loading
	this.hideLoading = function(){
		$('.loading-block').addClass('none');
		actFogging('loading-block', false);
	}
	
	// show toast
	this.showToast = function(message){
		$('.toast-block').removeClass("none");
		$('#toastMes').text(message);

		setTimeout(function(){
			$('.toast-block').addClass("none");
		}, Constant.TOAST_TIME);
	}

	// show close acc
	this.showCloseAcc = function(){
		actFogging('closeacc-block', true);
		$('.closeacc-block').removeClass("none");
	}

	// hide close acc
	this.hideCloseAcc = function(){
		$('.closeacc-block').addClass("none");
		actFogging('closeacc-block', false);
	}

	// show dialog for get likes
	this.showDialogBidLikes = function(id){
			$('#hideDialogField').val(id);
			var appElement = document.querySelector('[ng-controller=dialogCtrl]');
			var $scope = angular.element(appElement).scope();
			$scope.bidLikeId = id;
			$scope.targetCountDialog = Constant.LIKE_MIN_BID;
			$scope.price = "";
			$rootScope.$applyAsync();

			actFogging('bid-dialog-block', true);
			$('.bid-dialog-block').removeClass("none");
	}

	// hide dialog for get likes
	this.hideDialogBidLikes = function(){
		$('.bid-dialog-block').addClass("none");
		actFogging('bid-dialog-block', false);
	}

	// set class fogging on activity
	var actFogging = function(elem, isShow){
		if(isShow)
			$('.' + elem).addClass('fogging');
		else
			$('.' + elem).removeClass('fogging');
	}

	this.setButAnim = function(isAnim){
		animSend(isAnim);
	}

	clickCancel();
	function clickCancel(e){
		$(".bid-dialog-content").click(function(e){
			e.stopPropagation();
		});

		$(".closeacc-content").click(function(e){
			e.stopPropagation();
		});
	}

	function animSend(isAnim){
		if(isAnim){
			$("#dialogSend").addClass("none");
			$("#dialogSendAnim").removeClass("none");
		}else if(!isAnim){
			$("#dialogSend").removeClass("none");
			$("#dialogSendAnim").addClass("none");
		}
	}

	// cancel scroll for little versions
	cancelScroll();
	function cancelScroll(){
		$(".loading-block:first").bind('scroll touchmove', function(e){
			e.preventDefault();
		});

		$(".closeacc-block:first").bind('scroll touchmove', function(e){
			e.preventDefault();
		});

		$(".bid-dialog-block:first").bind('scroll touchmove', function(e){
			e.preventDefault();
		});
	}

	$lang.getLang(Constant.MESSAGES_VIEW, function(lang){
		self.strings = lang;
	});
}]);

services_views.service("$loginView", ["$manager", "$location", "$dialogView", "$keyboardMonster", function($manager, $location, $dialogView, $keyboardMonster){
	var self = this;

	this.manageView = function($scope, response){
		if(response.status == Constant.OK_STATUS){
			this.okView($scope, response);
		}else{
			this.errView($scope, response);
		}
		$scope.$applyAsync();
	}
	
	this.okView = function($scope, response){
		switch(response.action){
			case "auth":
				this.authOk($scope, response);
				break;
			case "load":
				this.loadOk($scope, response);
				break;
			case "show":
				this.showOk($scope, response);
				break;
		}
	}
	
	this.errView = function($scope, response){
		switch(response.action){
			case "auth":
				this.authErr($scope, response);
				break;
			case "load":
				this.loadErr($scope, response);
				break;
			case "show":
				this.showErr($scope, response);
				break;
		}
	}
	
	this.authOk = function($scope, response){
		$keyboardMonster.init();
		$location.path("/main");					//go to main and show mainActivity
	}
	
	this.authErr = function($scope, response){
		switch(response.data.errorCode){
			case Constant.ERR_CODE_BROWSER_AUTH:
				$dialogView.showToast($dialogView.strings.loginFail);
				break;
			case Constant.ERR_CODE_CONNECTOR_AUTH:
				$dialogView.showToast($dialogView.strings.connectErr);
				break;
			case Constant.ERR_CODE_BROWSER_INFO:
				$dialogView.showToast($dialogView.strings.readErr);
				break;
			case Constant.ERR_CODE_DATA_SAVE:
				$dialogView.showToast($dialogView.strings.writeErr);
				break;
			case Constant.ERR_CODE_CONNECTOR_CONNECTION:
				$dialogView.showToast($dialogView.strings.connectErr);
				break;
		}
	}
	
	this.loadOk = function($scope, response){
		
	}
	
	this.loadErr = function($scope, response){
		switch(response.data.errorCode){
			case Constant.ERR_CODE_DATA_LOAD:
				//nothing to do here
				break;
		}
	}

	this.remakeEarnBut = function(){
		$("#goEarnBut").addClass("none"); // hide go to earn button
	}

	this.setNavHeader = function(){
		$(".header").addClass("none");
		$(".nav-block").addClass("none");
	}

	this.setFrameWrap = function(){
		$("#frameWrap").addClass("frame-wrapping");
	}

	//init all functions in view
	this.initParams = function(){
		self.remakeEarnBut();
		self.setNavHeader();
		self.setFrameWrap();
	}
}]);

services_views.service("$newsView", ["$manager", "$location", "$dialogView", "$lang", function($manager, $location, $dialogView, $lang){
	var self = this;

	this.manageView = function($scope, response){
		if(response.status == Constant.OK_STATUS){
			this.okView($scope, response);
		}else{
			this.errView($scope, response);
		}
		$scope.$applyAsync();
	}
	
	this.okView = function($scope, response){
		switch(response.action){
			case "news":
				this.newsOk($scope, response);
				break;
			case "complite":
				this.compliteOk($scope, response);
				break;
		}
	}
	
	this.errView = function($scope, response){
		
		switch(response.action){
			case "news":
				this.newsErr($scope, response);
				break;
			case "complite":
				this.compliteErr($scope, response);
				break;
		}
	}
	
	this.newsOk = function($scope, response){
		$scope.news = response.data.news;
		setTimeout(function(){
			for(n in $scope.news){
				eval($scope.news[n].getJs());	
			}
		}, 500);
	}
	
	this.newsErr = function($scope, response){
		switch(response.data.errorCode){
			case Constant.ERR_CODE_CONNECTOR_NEWS:
				//nothing to do here
				break;
			case Constant.ERR_CODE_CONNECTOR_CONNECTION:
				$dialogView.showToast($dialogView.strings.connectErr);
				break;
		}
	}
	
	this.compliteOk = function($scope, response){
		$manager.instance.getUser().setCash(response.data.cash);
		$manager.instance.setCash();
		//$("#news_id_"+response.data.name).fadeOut("fast");		bug when multiple ids need to hide in news
		if(response.data.message != "")
			$dialogView.showToast(response.data.message);
	}
	
	this.compliteErr = function($scope, response){
		switch(response.data.errorCode){
			case Constant.ERR_CODE_CONNECTOR_COMPLITE:
				$dialogView.showToast($dialogView.strings.newsServerErr);
				break;
			case Constant.ERR_CODE_CONNECTOR_CONNECTION:
				$dialogView.showToast($dialogView.strings.connectErr);
				break;
		}
	}
	
	this.setHeight = function(){
		return {
			height: (window.innerHeight - 96) + "px"
		}
	}

	this.remakeEarnBut = function(){
		$("#goEarnBut").removeClass("none"); // show go to earn button
		$("#goEarnBut").find("div").removeClass("goearn-but-bottom");
	}

	this.setNavHeader = function(){
		$(".header").removeClass("none");
		$(".nav-block").removeClass("none");
	}

	this.setFrameWrap = function(){
		$("#frameWrap").addClass("frame-wrapping");
	}
	
	this.show = function(){
		$("#newsWrapBlck").removeClass("none");
	}
	
	this.scrollToTop = function(){
		$("#frameWrap").scrollTop(0);
	}

	//init all functions in view
	this.initParams = function(){
		self.remakeEarnBut();
		self.setNavHeader();
		self.setFrameWrap();
		self.scrollToTop();
	}
}]);

services_views.service("$donateView", ["$manager", "$dialogView", function($manager, $dialogView){
	var self = this;

	this.manageView = function($scope, response){
		if(response.status == Constant.OK_STATUS){
			this.okView($scope, response);
		}else{
			this.errView($scope, response);
		}
		$scope.$applyAsync();
	}
	
	this.okView = function($scope, response){
		switch(response.action){
			case "store":
				this.storeOk($scope, response);
				break;
		}
	}
	
	this.errView = function($scope, response){
		switch(response.action){
			case "store":
				this.storeErr($scope, response);
				break;
		}
	}
	
	this.storeOk = function($scope, response){
		
	}
	
	this.storeErr = function($scope, response){
		switch(response.data.errorCode){
			case Constant.ERR_CODE_LOAD_STORE:
				$dialogView.showToast($dialogView.strings.connectErr);
				break;
		}
	}
	
	this.render = function(product){
		Log.d("RENDER", product.alias + " " + product.price );
		$("#"+product.id+"_title").text(product.alias);
		$("#"+product.id+"_price").text(product.price);
		if(product.type == store.PAID_SUBSCRIPTION){
			if(product.owned){
				$("#"+product.id+"_status").text("owned");
			}else{
				$("#"+product.id+"_status").text("not owned");
			}
		}
	}

	this.setDonateContent = function(id){
		$("#diamSel").removeClass("donate-select-active");
		$("#premSel").removeClass("donate-select-active");
		$("#turboSel").removeClass("donate-select-active");

		$("#diamBlock").addClass("none");
		$("#premBlock").addClass("none");
		$("#turboBlock").addClass("none");

		$("#" + id + "Sel").addClass("donate-select-active");
		$("#" + id + "Block").removeClass("none");
	}

	this.setHeight = function(){
		return {
			height: (window.innerHeight - 146) + "px"
		}
	}

	this.remakeEarnBut = function(){
		$("#goEarnBut").addClass("none"); // hide go to earn button
		$("#goEarnBut").find("div").removeClass("goearn-but-bottom");
	}

	this.setNavHeader = function(){
		$(".header").removeClass("none");
		$(".nav-block").removeClass("none");
	}

	this.setFrameWrap = function(){
		$("#frameWrap").addClass("frame-wrapping");
	}
	
	this.scrollToTop = function(){
		$("#frameWrap").scrollTop(0);
	}

	//init all functions in view
	this.initParams = function(){
		self.remakeEarnBut();
		self.setNavHeader();
		self.setFrameWrap();
		self.scrollToTop();
	}
}]);

services_views.service("$mainView", ["$manager", "$mainLang", "$rootScope", "$dialogView", "$demon", function($manager, $mainLang, $rootScope, $dialogView, $demon){

	var self = this;
	var swipe = null;
	var guideNum = 1;
	this.isUpdating = false;
	this.scrollTop = 0;
	
	this.initSwipe = function(){
		var mainWrap = document.getElementById("mainWrap");
		swipe = new Swiper(mainWrap, Swiper.SELF, Swiper.screenHeight, "y", Swiper.BOT, 15, 0, function(type){
			switch(type){
				case Swiper.START:
					break;
				case Swiper.GOAL:
					$(".main-update-ready").removeClass("none");
					break;
				case Swiper.ENABLE_END:
					if(!self.isUpdating){
						$(".main-update-ready").addClass("none");
						$(".main-update-now").removeClass("none");
						self.isUpdating = true;
						var appElement = document.querySelector('[ng-controller=mainCtrl]');
						var $scope = angular.element(appElement).scope();
						$scope.update();
						//setTimeout(self.updateEnd, 4000);
					}
					break;
				case Swiper.DISABLE_END:
					$(".main-update-ready").addClass("none");
					$(".main-update-now").addClass("none");
					break;
			}
		});
		
		swipe.setIsActive(true);
		scrollListener();
	}
	
	this.updateEnd = function(){
		self.isUpdating = false;
		$(".main-update-now").addClass("none");
		swipe.goStartPos();
	}

	this.manageView = function($scope, response){
		if(response.status == Constant.OK_STATUS){
			this.okView($scope, response);
		}else{
			this.errView($scope, response);
		}
		$scope.$applyAsync();
	}
	
	this.okView = function($scope, response){
		switch(response.action){
			case "update":
				this.updateOk($scope, response);
				break;
		}
	}
	
	this.errView = function($scope, response){
		switch(response.action){
			case "update":
				this.updateErr($scope, response);
				break;
		}
	}
	
	this.updateOk = function($scope, response){
		this.setInfo($scope, $manager.instance.getUser());
		this.updateEnd();
	}
	
	this.updateErr = function($scope, response){
		this.updateEnd();
		switch(response.data.errorCode){
			case Constant.ERR_CODE_BROWSER_UPDATE:
				$dialogView.showToast($dialogView.strings.readErr);
				break;
			case Constant.ERR_CODE_CONNECTOR_UPDATE:
				$dialogView.showToast($dialogView.strings.connectErr);
				break;
			case Constant.ERR_CODE_CONNECTOR_CONNECTION:
				$dialogView.showToast($dialogView.strings.connectErr);
				break;
		}
	}
	
	/* helping start */
	this.setInfo = function($scope, user){
		$scope.subscribersCount = user.getSubscribers();
		$scope.viewsCount = user.getViewsCount();
		$scope.videos = user.getVideos();
		if($scope.videos.length == 0)
			$(".main-notasks-block").removeClass("none");
		$scope.userLvl = user.getXpInfo().getLvl();
		$scope.userXp = user.getXpInfo().getXp();
		$scope.lvlProgress = ((user.getXpInfo().getXp() * 100) / 1000) + "%";
		$rootScope.profileAvatar = user.getProfileAvatar();
		$rootScope.nick = user.getNick();
		this.setAchieves(user);
		this.setCash(user.getCash());
	}
	
	this.setCash = function(cash){
		$rootScope.freeSum = cash.getFreeSum();
	}
	/* helping end */
	
	function scrollListener(){
		document.getElementById("frame").addEventListener("scroll", scroll);
	}
	
	this.removeScrollListener = function(){
		document.getElementById("frame").removeEventListener("scroll", scroll);
	}
	
	function scroll(){
		if(this.scrollTop == 0){
			swipe.setIsActive(true);
		}
		else{
			swipe.setIsActive(false);
		}
	}
	
	this.setAchieves = function(user){
		var $scope = angular.element(document.querySelector('[ng-controller=mainCtrl]')).scope();
		createAchieves($scope, user);
	}

	this.setHeight = function(){
		return {
			height: (window.innerHeight - 293) + "px"
		}
	}

	this.setMainImages = function(index){
		$(".quest-elem:eq(" + index + ")").parent().removeClass("none");

		var left = ($(".quest-elem:eq(" + index + ")").width() - $(".quest-elem:eq(" + index + ")").parent().find("div.quest-views-field").innerWidth()) / 2;
		var top = ($(".quest-elem:eq(" + index + ")").height() - $(".quest-elem:eq(" + index + ")").parent().find("div.quest-views-field").innerHeight()) / 2;

		$(".quest-elem:eq(" + index + ")").parent().find("div.quest-views-field").css("left", left + "px");
		$(".quest-elem:eq(" + index + ")").parent().find("div.quest-views-field").css("top", top + "px");
	}

	this.setGuideVideo = function(){
		if($manager.instance.getUser().getVideos().length > 0){
			$rootScope.guideVideo = $manager.instance.getUser().getVideos()[0];
		}
	}

	this.remakeEarnBut = function(){
		$("#goEarnBut").removeClass("none"); // show go to earn button
		$("#goEarnBut").find("div").removeClass("goearn-but-bottom");
	}

	this.setNavHeader = function(){
		$(".header").removeClass("none");
		$(".nav-block").removeClass("none");
	}

	this.setFrameWrap = function(){
		$("#frameWrap").addClass("frame-wrapping");
	}
	
	this.scrollToTop = function(){
		$("#frameWrap").scrollTop(0);
	}

	this.setGuideFirst = function(){
		// set white images and up to the front
		$(".header-right-coins-block:first").addClass("guide-zindex guide-relative");
		$(".nav-elem-bid:first").addClass("guide-zindex");
		$(".nav-elem-bid:first").attr("src", "images/nav_bid_active.png");
		$(".nav-elem-tasks:first").addClass("guide-zindex");
		$(".nav-elem-tasks:first").attr("src", "images/nav_tasks_active.png");
		$(".nav-elem-donate:first").addClass("guide-zindex");
		$(".nav-elem-donate:first").attr("src", "images/nav_donate_active.png");
		$(".nav-elem-main:first").addClass("guide-zindex");
		$(".nav-elem-news:first").addClass("guide-zindex");
		$(".nav-elem-news:first").attr("src", "images/nav_news_active.png");

		// show guide makets
		$(".guide-block:first").removeClass("none");
		$(".guide-action:first").removeClass("none");

		$(".guide-action:first").bind('touchmove scroll', function(e){
			e.preventDefault();
		});
	}

	this.setGuide = function(){
		if(guideNum == 1){
			// hide first step (remove white images and down elements)
			$(".header-right-coins-block:first").removeClass("guide-zindex guide-relative");
			$(".nav-elem-bid:first").removeClass("guide-zindex");
			$(".nav-elem-bid:first").attr("src", "images/nav_bid_inactive.png");
			$(".nav-elem-tasks:first").removeClass("guide-zindex");
			$(".nav-elem-tasks:first").attr("src", "images/nav_tasks_inactive.png");
			$(".nav-elem-donate:first").removeClass("guide-zindex");
			$(".nav-elem-donate:first").attr("src", "images/nav_donate_inactive.png");
			$(".nav-elem-main:first").removeClass("guide-zindex");
			$(".nav-elem-news:first").removeClass("guide-zindex");
			$(".nav-elem-news:first").attr("src", "images/nav_news_inactive.png");
			$(".goearn-but-block:first").removeClass("guide-zindex");
			
			// hide blocks from first step
			$(".guide-diamonds:first").addClass("none");
			$(".guide-goearn-text:first").addClass("none");
			$(".guide-goearn-block:first").addClass("none");
			$(".guide-navs-block:first").addClass("none");
			
			// show blocks from second step(up quest)
			$(".guide-quest:first").removeClass("none");

			// change white circles and button text to second step
			$("#mainWrap").attr("style", "margin-top:-150px");
			$("#guideFirst").removeClass("guide-circle-active");
			$("#guideFirst").addClass("guide-circle-inactive");
			$("#guideSecond").removeClass("guide-circle-inactive");
			$("#guideSecond").addClass("guide-circle-active");
			$(".guide-but").text($dialogView.strings.guideReadyText);

			guideNum = 2;
		}else{
			// hide blocks from second step(down quest)
			$(".guide-quest:first").addClass("none");

			// show blocks from first step
			$(".guide-diamonds:first").removeClass("none");
			$(".guide-goearn-text:first").removeClass("none");
			$(".guide-goearn-block:first").removeClass("none");
			$(".guide-navs-block:first").removeClass("none");

			// change white circles and button text to first step
			$("#mainWrap").attr("style", "margin-top:0px");
			$("#guideFirst").removeClass("guide-circle-inactive");
			$("#guideFirst").addClass("guide-circle-active");
			$("#guideSecond").removeClass("guide-circle-active");
			$("#guideSecond").addClass("guide-circle-inactive");
			$(".guide-but").text($dialogView.strings.guideNextText);

			// hide guide makets
			$(".guide-block:first").addClass("none");
			$(".guide-action:first").addClass("none");

			guideNum = 1;
			
			$manager.instance.getBot().run(function(result){
				$dialogView.showToast($dialogView.strings.activeEarnText);
			});
		}
	}
	
	function createAchieves($scope, user){
		var premium = {};
		var turbo = {};
		var mass = [];
		
		if(user.getPremium())
			premium.src = "images/premium.png";
		else
			premium.src = "images/premium_none.png";
		premium.href = '#/donate/premium';
		mass.push(premium);
		
		var srcs = ["turbo_none", "turbo_1", "turbo_2", "turbo_3", "turbo_1"];
		turbo.src = "images/"+srcs[user.getTurbo()]+".png";
		turbo.href = '#/donate/turbo';
		mass.push(turbo);
		var achieves = user.getAchieves();
		for(var i=0; i<achieves.length; i++){
			var achieve = {};
			achieve.src = "images/achieves/" + achieves[i] +".png";
			achieve.href = 'javascript:void(0)';
			mass.push(achieve);
		}
		if(typeof $scope !== "undefined")
			$scope.achieves = mass;
	}

	//init all functions in view
	this.initParams = function(){
		self.remakeEarnBut();
		self.setNavHeader();
		self.setFrameWrap();
		self.scrollToTop();
	}
}]);


services_views.service("$tasksView", ["$manager", "$rootScope", "$action", "$mainView", "$dialogView", function($manager, $rootScope, $action, $mainView, $dialogView){
	var self = this;
	var swipeUpdate = null;
	var guideNum = 1;
	this.initSwipeOk = false;
	this.scrollTop = 0;
	this.isUpdating = false;
	
	this.initSwipe = function(){
		var tasksWrap = document.getElementById("tasksWrap");
		swipeUpdate = new Swiper(tasksWrap, Swiper.SELF, Swiper.screenHeight, "y", Swiper.BOT, 15, 0, function(type){
			switch(type){
				case Swiper.START:
					break;
				case Swiper.GOAL:
					$(".tasks-update-ready").removeClass("none");
					break;
				case Swiper.ENABLE_END:
					if(!self.isUpdating){
						$(".tasks-update-ready").addClass("none");
						$(".tasks-update-now").removeClass("none");
						self.isUpdating = true;
						var appElement = document.querySelector('[ng-controller=tasksCtrl]');
						var $scope = angular.element(appElement).scope();
						$action.tasks($scope);
					}
					break;
				case Swiper.DISABLE_END:
					$(".tasks-update-ready").addClass("none");
					$(".tasks-update-now").addClass("none");
					break;
			}
		});
		this.initSwipeOk = true;
		swipeUpdate.setIsActive(true);
		scrollListener();
	}

	this.manageView = function($scope, response){
		if(response.status == Constant.OK_STATUS){
			this.okView($scope, response);
		}else{
			this.errView($scope, response);
		}
		$scope.$applyAsync();
	}
	
	this.initSwipes = function($scope){
		$(".tasks-arr").each(function(){
			var element = this;
			var swipe = new Swiper(element, Swiper.SELF, Swiper.SELF, "x", Swiper.LEFT, 60, 0, function(type){
				switch(type){
					case Swiper.START:
						swipeUpdate.setIsActive(false);
						break;
					case Swiper.GOAL:
						
						break;
					case Swiper.ENABLE_END:
						swipe.setIsActive(false);
						var task = self.getTask($scope, $(element).attr('data-task'));
						if(task != null){
							swipe.setEnd(Swiper.screenWidth);
							swipe.goEnd();
							setTimeout(function(){
								$("#task_"+task.getId()).fadeOut(200, function(){
									$("#task_"+task.getId()).remove();
								});
							}, 300);
							$scope.deleteTask(task);
						}
						setTimeout(function(){swipeUpdate.setIsActive(true);}, 200);
						
						break;
					case Swiper.DISABLE_END:
						setTimeout(function(){swipeUpdate.setIsActive(true);}, 200);
						swipe.setIsActive(false);
						break;
				}
			});
			swipe.setMetric("");
			//swipe.setIsActive(true);
			var rightBlock = $(element).find(".tasks-delete-block:first");
			$(rightBlock).bind("touchstart", function(event){
				swipe.setIsActive(true);
				swipe.handleTouchStart(event, swipe);
			});

			$(rightBlock).bind("touchmove", function(event){
				swipe.handleTouchMove(event, swipe);
			});

			$(rightBlock).bind("touchend", function(event){
				swipe.handleTouchEnd(event, swipe);
			});
		});
	}
	
	this.getTask = function($scope, id){
		for(task in $scope.tasks){
			if($scope.tasks[task].getId() == id)
				return $scope.tasks[task];
		}
		return null;
	}
	
	this.okView = function($scope, response){
		switch(response.action){
			case "tasks":
				this.tasksOk($scope, response);
				break;
			case "delete":
				this.deleteOk($scope, response);
				break;
		}
	}
	
	this.errView = function($scope, response){
		switch(response.action){
			case "tasks":
				this.tasksErr($scope, response);
				break;
			case "delete":
				this.deleteErr($scope, response);
				break;
		}
	}
	
	this.tasksOk = function($scope, response){
		$scope.tasks = response.data.tasks;
		if($scope.tasks.length == 0){
			$(".tasks-notasks-block:first").removeClass("none");
			$(".tasks-wrap:first").addClass("tasks-notasks-height");
		}
		if(this.initSwipeOk)
			this.updateEnd();
		setTimeout(function(){
			self.initSwipes($scope);
			setTasksHeight();
		}, 500);
	}
	
	this.deleteOk = function($scope, response){
		var task = response.data.task;
		$manager.instance.getUser().setCash(response.data.cash);
		$mainView.setCash(response.data.cash);
		setTasksHeight();
	}
	
	this.updateEnd = function(){
		self.isUpdating = false;
		$(".tasks-update-now").addClass("none");
		swipeUpdate.goStartPos();
	}
	
	function scrollListener(){
		document.getElementById("frame").addEventListener("scroll", scroll);
	}
	
	this.removeScrollListener = function(){
		document.getElementById("frame").removeEventListener("scroll", scroll);
	}
	
	function scroll(){
		if(this.scrollTop == 0){
			swipeUpdate.setIsActive(true);
		}
		else{
			swipeUpdate.setIsActive(false);
		}
	}
	
	this.tasksErr = function($scope, response){
		switch(response.data.errorCode){
			case Constant.ERR_CODE_CONNECTOR_TASKS:
				$dialogView.showToast($dialogView.strings.connectErr);
				break;
			case Constant.ERR_CODE_CONNECTOR_CONNECTION:
				$dialogView.showToast($dialogView.strings.connectErr);
				break;
		}
	}
	
	this.deleteErr = function($scope, response){
		switch(response.data.errorCode){
			case Constant.ERR_CODE_CONNECTOR_DELETE:
				$dialogView.showToast($dialogView.strings.connectErr);
				break;
			case Constant.ERR_CODE_CONNECTOR_CONNECTION:
				$dialogView.showToast($dialogView.strings.connectErr);
				break;
		}
	}
	
	this.setHeight = function(){
		return {
			height: (window.innerHeight - 96) + "px"
		}
	}

	this.setBgHeight = function(index){
		var height = $(".tasks-block:eq(" + index + ")").innerHeight();
		return {
			height: height + "px",
			"display" : "inline-block"
		}
	}

	this.setTasksImages = function(index){
		$(".tasks-image-elem:eq(" + index + ")").removeClass("none");
	}

	this.remakeEarnBut = function(){
		$("#goEarnBut").removeClass("none"); // show go to earn button
		$("#goEarnBut").find("div").removeClass("goearn-but-bottom");
	}

	this.setNavHeader = function(){
		$(".header").removeClass("none");
		$(".nav-block").removeClass("none");
	}

	this.setFrameWrap = function(){
		$("#frameWrap").addClass("frame-wrapping");
	}
	
	this.scrollToTop = function(){
		$("#frameWrap").scrollTop(0);
	}

	function setTasksHeight(){
		var allHeight = 0;
		$(".tasks-elem").each(function(){
			allHeight = allHeight + $(this).height();
		});

		if((window.innerHeight - 96) < allHeight)
			$(".tasks-wrap:first").addClass("tasks-notasks-padding");
		else
			$(".tasks-all").css("height", "100%");
	}

	//init all functions in view
	this.initParams = function(){
		self.remakeEarnBut();
		self.setNavHeader();
		self.setFrameWrap();
		self.scrollToTop();
	}
}]);

services_views.service("$earnView", ["$manager", "$dialogView", function($manager, $dialogView){
	var self = this;

	this.manageView = function($scope, response){
		if(response.status == Constant.OK_STATUS){
			this.okView($scope, response);
		}else{
			this.errView($scope, response);
		}
		$scope.$applyAsync();
	}
	
	this.okView = function($scope, response){
		switch(response.action){
			case "run":
				this.runOk($scope, response);
				break;
			case "stop":
				this.stopOk($scope, response);
				break;
		}
	}
	
	this.errView = function($scope, response){
		switch(response.action){
			case "run":
				this.runErr($scope, response);
				break;
			case "stop":
				this.stopErr($scope, response);
				break;
		}
	}
	
	this.runOk = function($scope, response){
		this.centerEarnAnim(true);
	}
	
	this.stopOk = function($scope, response){
		this.centerEarnAnim(false);
	}
	
	this.runErr = function($scope, response){
		switch(response.data.errorCode){
			case Constant.ERR_CODE_BOT_RUN:
				$dialogView.showToast($dialogView.strings.runErr);
				break;
		}
	}
	
	this.stopErr = function($scope, response){
		switch(response.data.errorCode){
			case Constant.ERR_CODE_BOT_STOP:
				$dialogView.showToast($dialogView.strings.stopErr);
				break;
		}
	}

	this.hideHint = function(){
		$(".earn-top-mes-block").css("opacity", "0");
	}

	this.showHint = function(){
		$(".earn-top-mes-block").fadeTo(Constant.FADE_FAST, 1, function(){});
	}

	this.centerEarnAnim = function(isStart){
		if(isStart){
			$('.earn-start').addClass('none');
			$('.earn-anim').removeClass('none');
		}else{
			$('.earn-start').removeClass('none');
			$('.earn-anim').addClass('none');
		}
	}

	this.setHeight = function(){
		return {
			height: (window.innerHeight - 220) + "px"
		}
	}

	this.remakeEarnBut = function(){
		$("#goEarnBut").addClass("none"); // hide go to earn button
	}

	this.setNavHeader = function(){
		$(".header").removeClass("none");
		$(".nav-block").removeClass("none");
	}

	this.setFrameWrap = function(){
		$("#frameWrap").addClass("frame-wrapping");
	}

	//init all functions in view
	this.initParams = function(){
		self.remakeEarnBut();
		self.setNavHeader();
		self.setFrameWrap();
	}
}]);

services_views.service("$bidLikeView", ["$manager", "$mainView", "$dialogView", function($manager, $mainView, $dialogView){
	var self = this;

	this.manageView = function($scope, response){
		if(response.status == Constant.OK_STATUS){
			this.okView($scope, response);
		}else{
			this.errView($scope, response);
		}
		$scope.$applyAsync();
	}
	
	this.okView = function($scope, response){
		switch(response.action){
			case "bid":
				this.bidOk($scope, response);
				break;
		}
	}
	
	this.errView = function($scope, response){
		switch(response.action){
			case "bid":
				this.bidErr($scope, response);
				break;
		}
	}
	
	this.bidOk = function($scope, response){
		animSend(false);
		$dialogView.showToast($dialogView.strings.bidOk);
		$mainView.setCash(response.data.cash);

		//$scope.targetCount = 0;
		//$scope.applyAsync();
	}
	
	this.bidErr = function($scope, response){
		animSend(false);
		switch(response.data.errorCode){
			case Constant.ERR_CODE_CONNECTOR_BID:
				$dialogView.showToast($dialogView.strings.bidFail);
				break;
			case Constant.ERR_CODE_BROWSER_BID:
				$dialogView.showToast($dialogView.strings.mhFail);
				break;
			case Constant.ERR_CODE_CONNECTOR_CONNECTION:
				$dialogView.showToast($dialogView.strings.connectErr);
				break;
		}
	}
	
	this.setVideos = function($scope){
		$scope.videos = $manager.instance.getUser().getVideos();
		if($scope.videos.length == 0){
			$('.bid-like-notasks-block:first').removeClass("none");
			$('.bid-like-list-block:first').css("padding-bottom", "0");
		}

		//$scope.$applyAsync();
	}

	//переключатель кнопок в накрутке лайков
	this.switcherLikes = function($scope, num){
		if(num == 1){
			//переключить кнопки
			$('#butLikeList').removeClass("bid-but-inactive").addClass("bid-but-active");
			$('#butLikeLink').removeClass("bid-but-active").addClass("bid-but-inactive");

			//переключить контент
			$('#blockLikeList').removeClass("none");
			$('#blockLikeLink').addClass("none");

			if($scope.videos.length == 0)
				$('.bid-like-notasks-block:first').removeClass("none");
		} else if(num == 2){
			$('#butLikeList').removeClass("bid-but-active").addClass("bid-but-inactive");
			$('#butLikeLink').removeClass("bid-but-inactive").addClass("bid-but-active");

			$('#blockLikeList').addClass("none");
			$('#blockLikeLink').removeClass("none");

			$('.bid-like-notasks-block:first').addClass("none");
		}
	}
	
	this.setPrice = function($scope, price, num){
		if(num == 1)
			$scope.price = price;
		else
			$scope.price = "";
	}

	this.setButAnim = function(isAnim){
		animSend(isAnim);
	}

	function animSend(isAnim){
		if(isAnim){
			$("#likeSend").addClass("none");
			$("#likeSendAnim").removeClass("none");
		}else if(!isAnim){
			$("#likeSend").removeClass("none");
			$("#likeSendAnim").addClass("none");
		}
	}
	
	this.setHeight = function(){
		return {
			height: (window.innerHeight - 206) + "px"
		}
	}

	this.remakeEarnBut = function(){
		$("#goEarnBut").removeClass("none"); // show go to earn button
		$("#goEarnBut").find("div").addClass("goearn-but-bottom");
	}

	this.setNavHeader = function(){
		$(".header").removeClass("none");
		$(".nav-block").removeClass("none");
	}

	this.setFrameWrap = function(){
		$("#frameWrap").addClass("frame-wrapping");
	}
	
	this.scrollToTop = function(){
		$("#frameWrap").scrollTop(0);
	}

	//init all functions in view
	this.initParams = function(){
		self.remakeEarnBut();
		self.setNavHeader();
		self.setFrameWrap();
		self.scrollToTop();
	}
}]);

services_views.service("$bidSubsView", ["$manager", "$dialogView", "$mainView", function($manager, $dialogView, $mainView){
	var self = this;

	this.manageView = function($scope, response){
		if(response.status == Constant.OK_STATUS){
			this.okView($scope, response);
		}else{
			this.errView($scope, response);
		}
		$scope.$applyAsync();
	}
	
	this.okView = function($scope, response){
		switch(response.action){
			case "bid":
				this.bidOk($scope, response);
				break;
		}
	}
	
	this.errView = function($scope, response){
		switch(response.action){
			case "bid":
				this.bidErr($scope, response);
				break;
		}
	}
	
	this.bidOk = function($scope, response){
		animSend(); 							//without params - remove all animations
		$dialogView.showToast($dialogView.strings.bidOk);
		$mainView.setCash(response.data.cash);
		$scope.rangeMax = response.data.cash.getFreeSum() / Constant.SUBSCRIBE_PRICE;

		//$scope.targetCountAcc = 0;
		//$scope.targetCountLink = 0;

		//$scope.applyAsync();
	}
	
	this.bidErr = function($scope, response){
		animSend();								//without params - remove all animations
		switch(response.data.errorCode){
			case Constant.ERR_CODE_CONNECTOR_BID:
				$dialogView.showToast($dialogView.strings.bidFail);
				break;
			case Constant.ERR_CODE_BROWSER_BID:
				$dialogView.showToast($dialogView.strings.mhFail);
				break;
			case Constant.ERR_CODE_CONNECTOR_CONNECTION:
				$dialogView.showToast($dialogView.strings.connectErr);
				break;
		}
	}

	this.checkSubscribeSetting = function(){
		if($manager.instance.getUser().getSetting(Constant.SUBSCRIBE_SETTING) == 1 || $manager.instance.getUser().getPremium()){
			$(".bid-subs-accept-block:first").addClass("none");
			$('#blockSubsAcc').removeClass("none");
			$("#subsBotButtons").removeClass("none");
			$("#goEarnBut").removeClass("none");
		}else{
			$(".bid-subs-accept-block:first").removeClass("none");
			$("#subsBotButtons").addClass("none");
			$("#goEarnBut").addClass("none");
		}
	}

	this.acceptSubscribe = function(){
		$(".bid-subs-accept-block:first").addClass("none");
		$('#blockSubsAcc').removeClass("none");
		$("#subsBotButtons").removeClass("none");
		$("#goEarnBut").removeClass("none");

		var val = $manager.instance.getUser().getSetting(Constant.SUBSCRIBE_SETTING) == 1 ? 0 : 1;
		$manager.instance.getDataManager().setSetting(Constant.SUBSCRIBE_SETTING, val, function(){});
	}

	//переключатель кнопок в накрутке подписчиков
	this.switcherSubs = function(num){
		if(num == 1){
			//переключить кнопки
			$('#butSubsAcc').removeClass("bid-but-inactive").addClass("bid-but-active");
			$('#butSubsLink').removeClass("bid-but-active").addClass("bid-but-inactive");

			//переключить контент
			$('#blockSubsAcc').removeClass("none");
			$('#blockSubsLink').addClass("none");
		} else if(num == 2){
			$('#butSubsAcc').removeClass("bid-but-active").addClass("bid-but-inactive");
			$('#butSubsLink').removeClass("bid-but-inactive").addClass("bid-but-active");

			$('#blockSubsAcc').addClass("none");
			$('#blockSubsLink').removeClass("none");
		}
	}
	
	this.setPrice = function($scope, price, num){
		if(num == 1)
			$scope.priceAcc = price;
		else if(num == 2)
			$scope.priceLink = price;
		else{
			$scope.priceAcc = "";
			$scope.priceLink = "";
		}
	}

	this.setButAnim = function(num, isAnim){
		animSend(num, isAnim);
	}

	function animSend(num, isAnim){
		if(num == 1){
			if(isAnim){
				$("#subsAccSend").addClass("none");
				$("#subsAccSendAnim").removeClass("none");
			}else if(!isAnim){
				$("#subsAccSend").removeClass("none");
				$("#subsAccSendAnim").addClass("none");
			}
		}else if(num == 2){
			if(isAnim){
				$("#subsLinkSend").addClass("none");
				$("#subsLinkSendAnim").removeClass("none");
			}else if(!isAnim){
				$("#subsLinkSend").removeClass("none");
				$("#subsLinkSendAnim").addClass("none");
			}
		}else{
			$("#subsAccSendAnim").addClass("none");
			$("#subsLinkSendAnim").addClass("none");
			
			$("#subsAccSend").removeClass("none");
			$("#subsLinkSend").removeClass("none");
		}
	}
	
	this.setHeight = function(){
		return {
			height: (window.innerHeight - 206) + "px"
		}
	}

	this.remakeEarnBut = function(){
		$("#goEarnBut").addClass("none"); // show go to earn button
		$("#goEarnBut").find("div").addClass("goearn-but-bottom");
	}

	this.setNavHeader = function(){
		$(".header").removeClass("none");
		$(".nav-block").removeClass("none");
	}

	this.setFrameWrap = function(){
		$("#frameWrap").addClass("frame-wrapping");
	}

	//init all functions in view
	this.initParams = function(){
		self.remakeEarnBut();
		self.setNavHeader();
		self.setFrameWrap();

		self.checkSubscribeSetting();
	}
}]);


services_views.service("$navView", function(){
	
	/* set background to buttons in navigation */
	this.designateBut = function(id){
		this.clearButtons();
		if(id){
			$('#' + id).addClass('nav-active');
			switch(id){
				case "likeTab":
					$('#' + id).find("img").attr("src", "images/nav_bid_active.png");
					break;
				case "tasksTab":
					$('#' + id).find("img").attr("src", "images/nav_tasks_active.png");
					break;
				case "donateTab":
					$('#' + id).find("img").attr("src", "images/nav_donate_active.png");
					break;
				case "mainTab":
					$('#' + id).find("img").attr("src", "images/nav_main_active.png");
					break;
				case "newsTab":
					$('#' + id).find("img").attr("src", "images/nav_news_active.png");
					$("#newsCounter").addClass("none");
					break;
			}
		}
	}

	/* delete background button before setting */
	this.clearButtons = function(){
		var navIds = ['likeTab', 'tasksTab', 'donateTab', 'mainTab', 'newsTab'];
		for(var but in navIds){
			$('#' + navIds[but]).removeClass('nav-active');
		}
		$('#' + navIds[0]).find("img").attr("src", "images/nav_bid_inactive.png");
		$('#' + navIds[1]).find("img").attr("src", "images/nav_tasks_inactive.png");
		$('#' + navIds[2]).find("img").attr("src", "images/nav_donate_inactive.png");
		$('#' + navIds[3]).find("img").attr("src", "images/nav_main_inactive.png");
		$('#' + navIds[4]).find("img").attr("src", "images/nav_news_inactive.png");
	}

	this.setNewsCounter = function(num){
		isCounter(num);
	}

	function isCounter(num){
		if(num == 0){
			$("#newsCounter").addClass("none");
		}else{
			$("#newsCounter").removeClass("none");
			$("#newsCounter").text(num);
		}
	}
});


services_views.service("$settingsView", ["$manager", "$location", "$dialogView", "$demon", "$keyboardMonster", function($manager, $location, $dialogView, $demon, $keyboardMonster){
	var self = this;
	
	this.manageView = function($scope, response){
		if(response.status == Constant.OK_STATUS){
			this.okView($scope, response);
		}else{
			this.errView($scope, response);
		}
		$scope.$applyAsync();
	}
	
	this.okView = function($scope, response){
		switch(response.action){
			case "logout":
				this.logoutOk($scope, response);
				break;
			case "version":
				this.versionOk($scope, response);
				break;
			case "apps":
				this.appsOk($scope, response);
				break;
		}
	}
	
	this.errView = function($scope, response){
		switch(response.action){
			case "logout":
				this.logoutErr($scope, response);
				break;
		}
	}

	this.logoutOk = function($scope, response){
		$demon.stopNewsDemon();
		$("#goEarnBut").addClass("none");
		$keyboardMonster.clear();
		$location.path("/login");					//go to main and show mainActivity
	}
	
	this.versionOk = function($scope, response){
		var curV = $manager.instance.getAppVersion().split(".").join("");
		var newV = response.data.version.split(".").join("");
		if(parseInt(curV) < parseInt(newV)){
			$scope.versionText = $scope.newVersionText + response.data.version;
			$(".settings-version:first").removeClass("none");
		}
	}

	this.appsOk = function($scope, response){
		$scope.apps = response.data.apps;

		if(response.data.apps.length > 0){
			if($manager.instance.getUser().isSafeUser()){
				$(".settings-otherapp-block:first").removeClass("none");
				$(".settings-rate-forborder").each(function(){
					$(this).addClass("settings-bottom-border");
				});
			}
		}
	}
	
	this.logoutErr = function($scope, response){
		switch(response.data.errorCode){
			case Constant.ERR_CODE_BROWSER_LOGOUT:
				$dialogView.showToast($dialogView.strings.readErr);
				break;
			case Constant.ERR_CODE_CONNECTOR_LOGOUT:
				$dialogView.showToast($dialogView.strings.connectErr);
				break;
			case Constant.ERR_CODE_DATA_CLEAR:
				$dialogView.showToast($dialogView.strings.writeErr);
				break;
			case Constant.ERR_CODE_CONNECTOR_CONNECTION:
				$dialogView.showToast($dialogView.strings.connectErr);
				break;
		}
	}

	this.sendMail = function(windowObj){
		windowObj.location = "mailto:" + Constant.MAIL;
	}

	this.watchGuide = function(){
		$manager.instance.getUser().setSetting(Constant.FIRSTTIME_SETTING, 1);
		$location.path("/main");
	}

	this.seePrivacy = function(windowObj){
		windowObj.location = "#/privacy";
	}

	this.remakeEarnBut = function(){
		$("#goEarnBut").addClass("none"); // hide go to earn button
	}

	this.setNavHeader = function(){
		$(".header").addClass("none");
		$(".nav-block").addClass("none");
	}
	
	this.scrollToTop = function(){
		$("#frameWrap").scrollTop(0);
	}

	this.setPremiumSwitcher = function(){
		if($manager.instance.getUser().getPremium()){
			$("#premBut").css("background-image", "url(images/switcher_active.png)");
			$("#premFollBlock").removeClass("settings-content-elem-disable");
			
			$("#premBut").parent().click(function(){
				return false;
			});
			
			$("#premFollBut").click(function(){
				var val = $manager.instance.getUser().getSetting(Constant.SUBSCRIBE_SETTING) == 1 ? 0 : 1;
				$manager.instance.getDataManager().setSetting(Constant.SUBSCRIBE_SETTING, val, function(){
					self.setFollowingSwitcher();
				});
			});
		}
	}

	this.setFollowingSwitcher = function(){
		if($manager.instance.getUser().getSetting(Constant.SUBSCRIBE_SETTING) == 1){
			$("#premFollBut").css("background-image", "url(images/switcher_active.png)");
		}else{
			$("#premFollBut").css("background-image", "url(images/switcher_inactive.png)");
		}
	}

	this.setAutoEarning = function(){
		setAutoEarnBut($manager.instance.getUser().getSetting(Constant.AUTOEARN_SETTING));

		$("#autoEarnBut").click(function(){
			var val = $manager.instance.getUser().getSetting(Constant.AUTOEARN_SETTING) == 1 ? 0 : 1;
			$manager.instance.getDataManager().setSetting(Constant.AUTOEARN_SETTING, val, function(){
				setAutoEarnBut(val);
			})
		});

		function setAutoEarnBut(isOn){
			if(isOn){
				$("#autoEarnBut").css("background-image", "url(images/switcher_active.png)");
			}else{
				$("#autoEarnBut").css("background-image", "url(images/switcher_inactive.png)");
			}
		}
	}

	this.setLinkOnApp = function(appId){
		navigator.app.loadUrl("https://play.google.com/store/apps/details?id=" + appId, {openExternal : true});
	}

	this.setImageOnApp = function(num){
		$(".settings-otherapp-elem-image:eq(" + num + ")").removeClass("none");
	}

	//init all functions in view
	this.initParams = function(){
		self.remakeEarnBut();
		self.setNavHeader();
		self.scrollToTop();

		self.setPremiumSwitcher();
		self.setFollowingSwitcher();
		self.setAutoEarning();
	}
}]);


services_views.service("$authTroubleView", function(){
	var self = this;

	this.feedBackUs = function(windowObj){
		windowObj.location = "mailto:" + Constant.MAIL;
	}
	
	this.scrollToTop = function(){
		$("#frameWrap").scrollTop(0);
	}

	//init all functions in view
	this.initParams = function(){
		self.scrollToTop();
	}
});


services_views.service("$topView", ["$manager", "$dialogView", function($manager, $dialogView){

	var timer;
	var self = this;
	
	this.manageView = function($scope, response){
		if(response.status == Constant.OK_STATUS){
			this.okView($scope, response);
		}else{
			this.errView($scope, response);
		}
		$scope.$applyAsync();
	}
	
	this.okView = function($scope, response){
		switch(response.action){
			case "top":
				this.topOk($scope, response);
				break;
		}
	}
	
	this.errView = function($scope, response){
		switch(response.action){
			case "top":
				this.topErr($scope, response);
				break;
		}
	}
	
	this.topOk = function($scope, response){
		$scope.tops = response.data.tops;
		this.setTimer(response.data.left);

		setDialogPrizePlaces($scope);
	}
	
	this.topErr = function($scope, response){
		switch(response.data.errorCode){
			case Constant.ERR_CODE_CONNECTOR_TOP:
				$dialogView.showToast($dialogView.strings.readErr);
				break;
			case Constant.ERR_CODE_CONNECTOR_CONNECTION:
				$dialogView.showToast($dialogView.strings.connectErr);
				break;
		}
	}
	
	this.showHelpDialog = function(){
		$(".top-dialog-block:first").removeClass("none");
	}
	
	this.hideHelpDialog = function(){
		$(".top-dialog-block:first").addClass("none");
	}
	
	$(".top-dialog-content:first").click(function(){
		return false;
	});
	
	this.remakeEarnBut = function(){
		$("#goEarnBut").addClass("none"); // hide go to earn button
	}

	this.setNavHeader = function(){
		$(".header").addClass("none");
		$(".nav-block").addClass("none");
	}
	
	this.scrollToTop = function(){
		$("#frameWrap").scrollTop(0);
	}

	this.clearTimer = function(){
		clearInterval(timer);
	}

	this.setTimer = function(seconds){
		var numsec = seconds;
		var ONE_HOUR = 3600;
		var ONE_MINUTE = 60;

		setTime();

		timer = setInterval(function(){
			if(numsec < 0)
				numsec = 86399;
			setTime();
		}, 1000);

		function getTime(){
			var hours = parseInt(numsec / ONE_HOUR);
			var mins = parseInt((numsec - (hours * ONE_HOUR)) / ONE_MINUTE);
			var secs = parseInt((numsec - (hours * ONE_HOUR)) - (mins * ONE_MINUTE));

			return setNull(hours) + ":" + setNull(mins) + ":" + setNull(secs);
		}

		function setTime(){
			$(".top-time:first").text(getTime());
			numsec--;
		}

		function setNull(num){
			return (num > 9) ? num : "0"+num;
		}
	}

	cancelScroll();
	function cancelScroll(){
		$(".top-dialog-block").bind("scroll touchmove", function(e){
			e.preventDefault();
		});
	}

	function setDialogPrizePlaces($scope){
		$scope.dialogPlace1Text = 1;
		$scope.dialogPlace2Text = 2;
		$scope.dialogPlace3Text = 3;
		$scope.dialogPlace4Text = 4;
		$scope.dialogPlace5Text = 5;
	}

	//init all functions in view
	this.initParams = function(){
		self.remakeEarnBut();
		self.setNavHeader();
		self.scrollToTop();
	}
}]);


services_views.service("$adView", ["$manager", "$adLoader", function($manager, $adLoader){
	var isInit = false;
	var self = this;
	var isLoaded = false;
	var canShowAd = false;
	var isFirst = true;
	var mode = Constant.AD_MOB_MODE;
	
	this.showAd = function(){
		if(isLoaded && canShowAd && !$manager.instance.getUser().getPremium()){
			if(mode == Constant.AD_MOB_MODE){
				AdMob.showInterstitial();
			}else if(mode == Constant.AD_MINE_MODE){
				$adLoader.show();
			}
		}
	}
	
	document.addEventListener("onAdLoaded", function (e) {
		self.loaded();
	});
	
	document.addEventListener("onAdDismiss", function (e){
		self.dismiss();
	});
	
	this.loaded = function(){
		isLoaded = true;
		var timeout = isFirst ? Constant.AD_INTERVAL_START : Constant.AD_INTERVAL;
		isFirst = false;
		setTimeout(function(){
			canShowAd = true;
		}, timeout);
	}
	
	this.dismiss = function(){
		isLoaded = false;
		canShowAd = false;
		if(mode == Constant.AD_MOB_MODE){
			AdMob.prepareInterstitial({adId:Constant.AD_ID, autoShow:false});
		}else if(mode == Constant.AD_MINE_MODE){
			$adLoader.prepareNext();
		}
	}
	
	this.init = function(){
		if(!isInit){
			isInit = true;
			$manager.instance.getConnector().ads(function(result){
				if(result.status == Constant.OK_STATUS && $manager.instance.getUser().isSafeUser()){
					if(result.ads.length > 0 && $manager.instance.getUser().isSafeUser()){
						mode = Constant.AD_MINE_MODE;
					}
				}
				if(mode == Constant.AD_MOB_MODE){
					self.prepareAdMob();
				}else if(mode == Constant.AD_MINE_MODE){
					self.prepareAdMine(result);
				}
			});
		}
	}
	
	this.prepareAdMob = function(){
		if(AdMob && !$manager.instance.getUser().getPremium()){
			setTimeout(function(){
					AdMob.prepareInterstitial( {adId:Constant.AD_ID, autoShow:false} );
			}, Constant.AD_TIMEOUT_BEGIN);
		}
	}
	
	this.prepareAdMine = function(result){
		if(!$manager.instance.getUser().getPremium()){
			setTimeout(function(){
					$adLoader.prepare(self, result.ads);
			}, Constant.AD_TIMEOUT_BEGIN);
		}
	}
	
	this.setMode = function(m){
		mode = m;
	}
}]);

services_views.service("$lvlPrizeView", function(){
	var self = this;
	
	this.setItems = function($scope){
		var arr = [];
		for(var i = 1; i <= 50; i++){
			var points = {};
			if(i < 10){
				points.num = i + $scope.lvlLevelText;
				points.text = "x" + (i * 10) + "<img class='lvlprize-coins-image' src='images/img_coins.png'>";
			}else if(i < 20){
				points.num = i + $scope.lvlLevelText;
				points.text = "x" + (i * 10) + "<img class='lvlprize-coins-image' src='images/img_coins.png'>" + $scope.andPrizeText + "x1" + "<img class='lvlprize-box-image' src='images/img_box.png'>";
			}else if(i == 20){
				points.num = i + $scope.lvlLevelText;
				points.text = "x1" + "<img class='lvlprize-other-image' src='images/turbo_1.png'>" + $scope.turboPrizeText;
			}else if(i < 40){
				points.num = i + $scope.lvlLevelText;
				points.text = "x" + (i * 10) + "<img class='lvlprize-coins-image' src='images/img_coins.png'>" + $scope.andPrizeText + "x1" + "<img class='lvlprize-box-image' src='images/img_box.png'>";
			}else if(i == 40){
				points.num = i + $scope.lvlLevelText;
				points.text = "x1" + "<img class='lvlprize-other-image' src='images/premium.png'>";
			}else{
				if(i == 50)
					points.num = i + "+";
				else
					points.num = i + $scope.lvlLevelText;
				points.text = "x" + (i * 10) + "<img class='lvlprize-coins-image' src='images/img_coins.png'>" + $scope.andPrizeText + "x1" + "<img class='lvlprize-box-image' src='images/img_box.png'>";
			}
			arr[i-1] = points;
		}
		$scope.points = arr;
	}

	this.remakeEarnBut = function(){
		$("#goEarnBut").addClass("none");
	}

	this.setNavHeader = function(){
		$(".header").addClass("none");
		$(".nav-block").addClass("none");
	}
	
	this.scrollToTop = function(){
		$("#frameWrap").scrollTop(0);
	}

	//init all functions in view
	this.initParams = function(){
		self.remakeEarnBut();
		self.setNavHeader();
		self.scrollToTop();
	}
});

services_views.service("$guideView", function(){

	this.setActionClick = function(view){
		$(".guide-action:first").click(function(){
			view.setGuide();
		});
	}

	this.setGuideImages = function(){
		$(".guide-quest-elem-block").removeClass("none");
	}
});


services_views.service("$mineAdView", ["$adLoader", function($adLoader){

	this.handleAd = function(windowObj, num){
		$adLoader.dismiss(windowObj, num);
	}
}]);


services_views.service("$privacyView", function(){
	var self = this;
	
	this.scrollToTop = function(){
		$("#frameWrap").scrollTop(0);
	}

	//init all functions in view
	this.initParams = function(){
		self.scrollToTop();
	}
});

services_views.service("$keyboardMonster", function(){
	
	this.init = function(){
		addKeyboardListeners();
	}
	
	this.clear = function(){
		removeKeyboardListeners();
	}
	
	function addKeyboardListeners(){
		window.addEventListener('native.hidekeyboard', keyboardHideHandler);
		window.addEventListener('native.showkeyboard', keyboardShowHandler);
	}
	
	function removeKeyboardListeners(){
		window.removeEventListener('native.hidekeyboard', keyboardHideHandler);
		window.removeEventListener('native.showkeyboard', keyboardShowHandler);
	}
	
	function keyboardHideHandler(e){
		$("#goEarnBut").removeClass("none");
		$("#likeBotButtons").removeClass("none");
		$("#questBotButtons").removeClass("none");
		$("#subsBotButtons").removeClass("none");
	}
	
	function keyboardShowHandler(e){
		$("#goEarnBut").addClass("none");
		$("#likeBotButtons").addClass("none");
		$("#questBotButtons").addClass("none");
		$("#subsBotButtons").addClass("none");
	}
});