var Bot = Base.extend({

	connector: null,
	dataManager: null,
	isRun: false,
	browser: null,
	pullTime: 0,
	pullTimeLikes: null,
	pullTimeSubscribes: null,
	waiting: null,
	timeoutId: null,
	manager: null,
	earned: 0,
	quests: null,
	switchedTimeout: 0,
	strings: {text: "", title: "", ticker: ""},
	limitsCnt: 0,

	constructor: function(manager, connector, dataManager, browser){
		Bot.self = this;
		var self = Bot.self;
		/*$lang = angular.element(document.body).injector().get('$lang');
		$lang.getLang(Constant.BOT_VIEW, function(lang){
			self.config.title = lang.title;
			self.config.text = lang.text;
			self.config.ticker = lang.title;
		});*/
		self.manager = manager;
		self.browser = browser;
		self.connector = connector;
		self.dataManager = dataManager;
		self.addEvents();
	},
	
	run: function(callback){
		var self = Bot.self;
		if(!self.isRun){
			self.waiting = callback;
			clearTimeout(self.switchedTimeout);
			cordova.plugins.backgroundMode.activate();
		}
		else{
			callback(Constant.OK_STATUS);
		}
	},
	
	addEvents: function(){
		var self = Bot.self;
		cordova.plugins.backgroundMode.onactivate = function () {
			var self = Bot.self;
			self.init(function(response){
				if(response == Constant.OK_STATUS){
					//start bot
					self.earned = 0;
					self.manager.payForQuest(0, self.earned);
					self.isRun = true;
					self.quests = new Array();
					self.timeoutId = null;
					self.limitsCnt = 0;
					self.getLang();
					
					cordova.plugins.backgroundMode.configure({
						 title:  self.strings.title,											//have to add language
						 text:   self.strings.text,
						 ticker: self.strings.ticker
					});
					setTimeout(self.cycle, self.pullTime);
					self.callWaiting(Constant.OK_STATUS, 0);
				}else{
					self.callWaiting(Constant.ERR_STATUS, 0);
				}
			});	
		};

		cordova.plugins.backgroundMode.ondeactivate = function () {
			self.earned = 0;
			self.manager.payForQuest(0, self.earned);
			self.isRun = false;
			self.callWaiting(Constant.OK_STATUS, 500);
			//cordova.plugins.notification.badge.clear();
		};
		
		cordova.plugins.backgroundMode.onfailure = function(errorCode) {
			
		};
	},
	
	init: function(callback){
		var self = Bot.self;
		if(self.browser.isLogin){
			callback(Constant.OK_STATUS);
		}else{
			callback(Constant.ERR_STATUS);
		}
	},
	
	getLang: function(){
		var self = Bot.self;
		var lang = Lang.getLang(self.manager.getUser().getLang(), Constant.BOT_VIEW);
		self.strings.title = lang.title;
		self.strings.text = lang.text;
		self.strings.ticker = lang.title;
	},
	
	stop: function(callback){
		var self = Bot.self;
		//stop bot
		self.isRun = false;
		//add status and check status for exit
		self.waiting = callback;
		clearTimeout(self.switchedTimeout);
		self.earned = 0;
		self.manager.payForQuest(0, self.earned);
		cordova.plugins.backgroundMode.deactivate();
	},
		
	cycle: function(){
		var self = Bot.self;
		if(self.quests.length == 0 && self.timeoutId == null){
			self.dataManager.getTypesLimitsTimes(function(result){
				if(result.status == Constant.OK_STATUS){
					Log.o("SPEED_LIMITS", result);
					self.setSpeed(result.likesPower, result.subscribesPower);
					var typesLimits = self.getTypesLimits(result);
					self.pullTimeLikes = result.likesTime;
					self.pullTimeSubscribes = result.subscribesTime;
					if(typesLimits != null){
						self.connector.getQuests(typesLimits, function(quests){				
							if(quests != null){
								if(self.isRun){
									self.pullQuests(quests);
								}else{
									//self.callWaiting(Constant.OK_STATUS);
								}
							}
							else{
								self.setCallPull(self);
							}
						});
					}else{
						self.setCallPull(self);
					}
				}else{
					self.setCallPull(self);
				}
			});
		}else{
			
		}
	},
	
	pullQuests: function(quests){
		var self = Bot.self;
		self.quests = quests;
		if(quests.length > 0){
			var quest = quests.pop();
			self.pull(quest, function(response){
				self.controll(quest, response, function(){
					if(self.isRun){
						self.pullTime = self.getPullTime(quest);
						
						self.timeoutId = setTimeout(function(){
							self.timeoutId = null;
							self.pullQuests(quests);
						}, self.pullTime);
					}else{
						//self.callWaiting(Constant.OK_STATUS);
					}
				});
			});
		}else{
			self.setCallPull(self);
		}
	},
	
	callWaiting: function(response, timeout){
		var self = Bot.self;
		clearTimeout(self.timeoutId);
		self.timeoutId = null;
		setTimeout(function(){
			self.waiting(response);
		}, timeout);
		
	},
	
	pull: function(quest, callback){
		var self = Bot.self;
		
		self.isInStorage(quest, function(response){
			if(response.status = Constant.OK_STATUS){
				if(!response.value){				
					if(quest.getType() == Constant.LIKE_TYPE){
						self.like(quest, callback);
					}else if(quest.getType() == Constant.SUBSCRIBE_TYPE){
						self.subscribe(quest, callback);
					}
				}else{								//is in storage
					quest.setNeedPay(false);					//set no pay it
					self.connector.setReady(quest, function(response){
						if(response != null){						//added to base
							callback(Constant.ERR_STATUS);
						}else{
							callback(Constant.ERR_STATUS);			//send error
						}
					});
				}
			}else{
				callback(Constant.ERR_STATUS);
			}
		});
	},
	
	controll: function(quest, response, callback){
		var self = Bot.self;
		if(self.isNumeric(response))
			response = parseInt(response, 10);
		
		switch(response){
			case Constant.OK_STATUS:
				//write to storage
				//write to base
				//sendReady()
				self.sendReady(quest, function(price){
					price = parseInt(price, 10);
					self.earned += price;
					if(self.isRun){
						self.manager.payForQuest(price, self.earned);
					}
					callback();
				});
				break;
			case Constant.ERR_STATUS:
				//nothing to do here yet
				callback();
				break;
			case Constant.ERR_CODE_BOT_LIMIT:
				Log.d("LIMIT", "WAIT FOR " + Constant.LIMIT_WAIT_TIME);
				self.limitsCnt++;
				clearTimeout(self.switchedTimeout);
				self.switchedTimeout = setTimeout(function(){
					callback();
				}, Constant.LIMIT_WAIT_TIME);
				break;
			case Constant.ERR_CODE_BOT_BEFORE:			//did action earlier
				//write to storage
				//write to base
				self.sendAlreadyDone(quest, function(response){
					callback();
				});
				
				break;
			case Constant.ERR_CODE_BOT_NOPE:			//page doesn't exist
				//report to base
				//sendReportQuest()
				self.sendReportQuest(quest, function(response){
					callback();
				});
				break;
		}
	},
	
	isNumeric: function(n){
		return !isNaN(parseFloat(n)) && isFinite(n);
	},
	
	setCallPull: function(self){
		if(self.isRun){
			
			var tm = parseInt(self.getQuestsTime(), 10);		//random value
			self.timeoutId = setTimeout(function(){
				if(self.isRun){
					self.timeoutId = null;
					self.cycle();
				}
				else{
					//self.callWaiting(Constant.OK_STATUS);
				}
			}, tm);
		}else{
			//self.callWaiting(Constant.OK_STATUS);
		}
	},
	
	isInStorage: function(quest, callback){
		var self = Bot.self;
		self.dataManager.isInStorage(quest, callback);
	},
		
	/* bot likes */
	like: function(quest, callback){
		var self = Bot.self;
		self.browser.like(quest, callback);
	},
	
	/* bot subscribes */
	subscribe: function(quest, callback){
		var self = Bot.self;
		self.browser.subscribe(quest, callback);
	},
	
	sendAlreadyDone: function(quest, callback){
		var self = Bot.self;
		self.dataManager.addQuest(quest, function(response){
			//response
			quest.setNeedPay(false);					//set no pay it
			self.connector.setReady(quest, callback);
		});
		//send to base already done task
	},
	
	sendReady: function(quest, callback){
		var self = Bot.self;
		
		self.dataManager.addQuest(quest, function(response){
			//response
			self.connector.setReady(quest, callback);
		});
	},
	
	sendReportQuest: function(quest, callback){
		var self = Bot.self;
		//self.dataManager.addQuest(quest, function(response){
			//response
			self.connector.reportQuest(quest, callback);
		//});
		
	},
	
	getQuestsTime: function(){
		var self = Bot.self;
		return self.getRandomInt(Constant.GET_QUESTS_MIN_TIME, Constant.GET_QUESTS_MAX_TIME);
	},
	
	getPullTime: function(quest){
		var self = Bot.self;
		if(quest.getType() == Constant.LIKE_TYPE)
			return self.pullTimeLikes;
		else if(quest.getType() == Constant.SUBSCRIBE_TYPE)
			return self.pullTimeSubscribes
		
	},
	
	getRandomInt: function(min, max)
	{
	  return Math.floor(Math.random() * (max - min + 1)) + min;
	},
	
	getTypesLimits: function(result){
		var self = Bot.self;
		//check in base normal
		var types = new Array();		//or null
		var limits = new Array();
		
		if(result.limitLikes > 0){
			types.push(Constant.LIKE_TYPE);
			limits.push(result.limitLikes);
		}
		if(result.limitSubscribes > 0 && self.limitsCnt < 5){
			types.push(Constant.SUBSCRIBE_TYPE);
			limits.push(result.limitSubscribes);
		}else{
			Log.d("LIMIT", self.limitsCnt);
		}
		
		if(types.length != 0 && limits.length != 0)
			return {types: types.join(","), limits: limits.join(",")};
		else
			return null;
	},
	
	getEarned: function(){
		return this.earned;
	},

	isRunnable: function(){
		return this.isRun;
	},
	
	paySum: function(sum){
		var self = Bot.self;
		self.earned += sum;
		if(self.isRun){
			self.manager.payForQuest(sum, self.earned);
		}
	},
	
	setSpeed:function(likesPower, subscribesPower){
		var self = Bot.self;
		self.manager.setSpeed(likesPower < subscribesPower ? likesPower : subscribesPower);
	}
		
},{ 
	self: this
});