var EmbedBrowser = Embed.extend({

	bot: null,
	isUniqLoad: true,

	constructor: function(){
		Embed.browser = this;
	},

	/* EmbedBrowser.bot starts */
	init: function(callback){
		var self = this;
		self.action = Constant.INIT_ACTION;
		var time = Constant.INIT_TIME;
		var toid = this.throwwer({action: self.action, time: time, callback: callback, val: Constant.ERR_STATUS});
		self.waiting = function(response){
			clearTimeout(toid);
			callback(response);
			self.waiting = null;
		}
		
		self.bot = window.open(encodeURI(Constant.HOME_PAGE), 'browser', 'hidden=yes');
		self.bot.val = "browser";
		self.bot.addEventListener('loadstop', loadStop);
		
		self.bot.addEventListener('loadstart', loadStart);
	},
	
	loadStart: function(){
		self.isUniqLoad = true;
		setTimeout(function(){
			$.get("js/gap/embedClear.js", function(data){
				self.bot.executeScript({code: data}, function(){
					self.bot.executeScript({code: "clear();"}, function(data){
						
					});
				});
			});
		}, Constant.CLEAR_TIMEOUT);
	},
	
	loadStop: function(){
		var self = this;
		if(self.isUniqLoad){
			self.isUniqLoad = false;
		
			$.get("js/gap/embedBrowser.js", function(data){
				self.bot.executeScript({code: data}, function(){
					self.bot.executeScript({code: "curPath();"}, function(data){
						data = JSON.parse(self.s(data));
						if(self.s(data.host) == Constant.ASK_HOST){		//it is ask
							self.route(data.path);
						}else{
							self.routeOuter(data.host, data.path); 	// another site
						}
					});
				});
			});
		}else
			
	},
	
	routeOuter: function(host, path){
		var self = this;
		var parts = path.split("/");
		this.curPath = path;
		//this.curPart = parts[1];
		switch(host){
			case Constant.VK_HOST:
				if(this.action == Constant.AUTH_ACTION){	//call auth vk method
					var method = self.getAuthMethod(this.data.authData);
					this.bot.executeScript({code: method});
				}
				break;
			case Constant.TT_HOST:
				if(this.action == Constant.AUTH_ACTION){	//call auth vk method
					var method = self.getAuthMethod(this.data.authData);
					this.bot.executeScript({code: method});
				}
				break;
			case Constant.FB_HOST:
				if(this.action == Constant.AUTH_ACTION){	//call auth vk method
					var method = self.getAuthMethod(this.data.authData);
					this.bot.executeScript({code: method});
				}
				break;
		}
	},
	
	/* set route by path */
	route: function route(path){
		var parts = path.split("/");
		var self = this;
		
		self.curPath = path;
		self.curPart = parts[1];
		if(parts.length > 1){
			switch(parts[1]){
				case Constant.LOGIN_PART:
					//bot.executeScript({code: "login();"});
					self.isLogin = false;
					if(self.action == Constant.AUTH_ACTION){			// call auth method
						var method = self.getAuthMethod(self.data.authData);
						self.bot.executeScript({code: method});
					}
					break;
				case Constant.ACCOUNT_PART:
					self.isLogin = true;
					switch(parts[2]){
						case Constant.WALL_PART:
							if(self.action == Constant.AUTH_ACTION){		//auth ok
									self.callWaiting(Constant.OK_STATUS);
							}
							if(self.action == Constant.INIT_ACTION){	
									self.callWaiting(Constant.OK_STATUS);
							}
							
							break;
						case Constant.SETTINGS_PART:
							if(self.action == Constant.LOGOUT_ACTION){		//call logout method
								self.bot.executeScript({code: "logout();"});
							}
							
							break;
					}
					
					break;
				case Constant.HOME_PART:
					this.isLogin = false;
					if(this.action == Constant.LOGOUT_ACTION){		//logout ok
							self.callWaiting(Constant.OK_STATUS);
					}
					if(this.action == Constant.INIT_ACTION){	
							self.callWaiting(Constant.OK_STATUS);
					}
					break;
				case Constant.PROMOTIONS_PART:
					this.isLogin = false;
					if(self.action == Constant.INIT_ACTION){							//shut promis call
						self.action == Constant.PROMOTIONS_ACTION;
						self.bot.executeScript({code: "shutPromotions();"}, function(){
							setTimeout(function(){
								self.action == Constant.INIT_ACTION;
								self.bot.executeScript({code: "goPage('"+Constant.HOME_PAGE+"');"});
							}, Constant.PROMOTIONS_TIME);
						});
					}
					if(this.action == Constant.PROMOTIONS_ACTION){
						
					}
					break;
				default:
					if(self.action == Constant.GET_INFO_ACTION){					//Get user info action
						this.bot.executeScript({code: "getUserInfo();"}, function(userInfo){
							userInfo = JSON.parse(self.s(userInfo));
							userInfo = new UserInfo(userInfo);
							
							self.callWaiting({userInfo: userInfo});
						});
					}
					if(self.action == Constant.GET_MH_ACTION){
						switch(self.data.bid.getType()){
							case Constant.LIKE_TYPE:
								self.bot.executeScript({code: "getLikeInfo();"}, function(data){
									data = JSON.parse(self.s(data));
									self.callWaiting(data);
								});
								break;
							case Constant.SUBSCRIBE_TYPE:
								self.bot.executeScript({code: "getSubscribeInfo();"}, function(data){
									data = JSON.parse(self.s(data));
									self.callWaiting(data);
								});
								break;
						}
					}
					break;
			}
		}else{
			
			
		}
	},

	/* EmbedBrowser.bot authorizations */
	auth: function(authData, callback){
		var self = this;
		this.action = Constant.AUTH_ACTION;
		if(this.isLogin){
			callback(Constant.OK_STATUS);
		}else{
			this.data = {authData: authData};
			var time = Constant.LOGIN_BASE_TIME;
			switch(this.data.authData.getAuthType()){
				case Constant.BASE_AUTH: time = Constant.LOGIN_BASE_TIME; break;
				case Constant.TT_AUTH: time = Constant.LOGIN_TT_TIME; break;
				case Constant.VK_AUTH: time = Constant.LOGIN_VK_TIME; break;
				case Constant.FB_AUTH: time = Constant.LOGIN_FB_TIME; break;
			}
			var toid = this.throwwer({action: this.action, time: time, callback: callback, val: Constant.ERR_STATUS});
			this.waiting = function(response){
				clearTimeout(toid);
				callback(response);
				self.waiting = null;
			}
			this.goPage(Constant.LOGIN_PAGE);
		}
	},


	/* EmbedBrowser.bot logouts */
	logout: function(callback){
		var self = this;
		this.action = Constant.LOGOUT_ACTION;
		if(this.isLogin){
			var toid = this.throwwer({action: this.action, time: Constant.LOGOUT_TIME, callback: callback, val: Constant.ERR_STATUS});
			this.waiting = function(response){
				clearTimeout(toid);
				callback(response);
				self.waiting = null;
			}
			this.goPage(Constant.SETTINGS_PAGE);
		}else{
			callback(Constant.OK_STATUS);	
		}
	},
	
	
	
	goPage: function(page){
		this.bot.executeScript({code: "goPage('"+page+"');"});
	},

	/* get user info */
	getUserInfo: function(user, callback){
		var self = this;
		this.action = Constant.GET_INFO_ACTION;
		if(this.isLogin){
			var toid = this.throwwer({action: this.action, time: Constant.GET_INFO_TIME, callback: callback, val: null});
			this.waiting = function(response){
				clearTimeout(toid);
				callback(response);
				self.waiting = null;
			}
			if(user.getNick() == null){
				this.bot.executeScript({code: "goProfile();"});
			}else{
				var profilePage = Constant.HOME_PAGE + user.getNick();
				this.goPage(profilePage);
			}
		}else{
			callback(Constant.ERR_STATUS);	
		}
	},

	/* update EmbedBrowser.bot */
	update: function(user, callback){
		this.getUserInfo(user, callback);
	},

	/* get meta and head from bid */
	getMetaHead: function(bid, callback){
		var self = this;
		self.action = Constant.GET_MH_ACTION;
		if(this.isLogin){
			var toid = this.throwwer({action: this.action, time: Constant.GET_MH_TIME, callback: callback, val: null});
			this.waiting = function(response){
				clearTimeout(toid);
				callback(response);
				self.waiting = null;
			}
			this.goPage(bid.getLink());
			this.data = {bid: bid};
		}else{
			callback(null);	
		}
		
	},
	
	getAuthMethod: function(authData){
		var loginPassword = "'"+authData.getLogin()+"','"+authData.getPassword()+"'";
		var method = "login_";
		switch(authData.getAuthType()){
			case Constant.BASE_AUTH: method += "base"; break;
			case Constant.TT_AUTH: method += "tt"; break;
			case Constant.VK_AUTH: method += "vk"; break;
			case Constant.FB_AUTH: method += "fb"; break;
		}
		return method+"("+loginPassword+");";
	},
	
	callWaiting: function(response){
		if(this.waiting != null){
			this.waiting(response);
			this.action = Constant.NULL_ACTION;
			this.waiting = null;
		}
	}
});