function Lang(){}

Lang.getLang = function(lang_code, view){
	var lang = null;
	switch(view){
		case Constant.LOGIN_VIEW:
			lang = Lang.getLogin(lang_code);
			break;
		case Constant.MAIN_VIEW:
			lang = Lang.getMain(lang_code);
			break;
		case Constant.TASKS_VIEW:
			lang = Lang.getTasks(lang_code);
			break;
		case Constant.EARN_VIEW:
			lang = Lang.getEarn(lang_code);
			break;
		case Constant.BID_VIEW:
			lang = Lang.getBid(lang_code);
			break;
		case Constant.NAV_VIEW:
			lang = Lang.getNav(lang_code);
			break;
		case Constant.DONATE_VIEW:
			lang = Lang.getDonate(lang_code);
			break;
		case Constant.SETTINGS_VIEW:
			lang = Lang.getSettings(lang_code);
			break;
		case Constant.DIALOG_VIEW:
			lang = Lang.getDialog(lang_code);
			break;
		case Constant.BOT_VIEW:
			lang = Lang.getBot(lang_code);
			break;
		case Constant.MESSAGES_VIEW:
			lang = Lang.getMessages(lang_code);
			break;
		case Constant.CORRECT_VIEW:
			lang = Lang.getCorrects(lang_code);
			break;
		case Constant.AUTHTROUBLE_VIEW:
			lang = Lang.getAuthTrouble(lang_code);
			break;
		case Constant.GUIDE_VIEW:
			lang = Lang.getGuide(lang_code);
			break;
		case Constant.TOP_VIEW:
			lang = Lang.getTop(lang_code);
			break;
		case Constant.LVLPRIZE_VIEW:
			lang = Lang.getLvlPrize(lang_code);
			break;
		case Constant.MINEAD_VIEW:
			lang = Lang.getMineAd(lang_code);
			break;
		case Constant.PRIVACY_VIEW:
			lang = Lang.getPrivacy(lang_code);
			break;
	}
	return lang;
}

Lang.getLogin = function(lang_code){
	var lang = null;
	switch(lang_code){
		case Constant.EN_LANG:
			lang = {
				authText: "Log in via Google+",
				privacyText: "Using our application you are accepting",
				privacyLinkText: "the user agreement",
				troubleText: "Troubles with authorization?"
			};
			break;
		case Constant.RU_LANG:
			lang = {
				authText: "Войти через Google+",
				privacyText: "Используя наше приложение, Вы соглашаетесь с",
				privacyLinkText: "пользовательским соглашением",
				troubleText: "Произошла проблема с авторизацией?"
			};
			break;
	}
	return lang;
}

Lang.getMain = function(lang_code){
	var lang = null;
	switch(lang_code){
		case Constant.EN_LANG:
			lang = {
				subscribersText: "Subscribers",
				viewsText: "Views",
				levelText: "Level",
				mainNoQuestText: "You have no videos yet"
			};
			break;
		case Constant.RU_LANG:
			lang = {
				subscribersText: "Подписчики",
				viewsText: "Просмотры",
				levelText: "Уровень",
				mainNoQuestText: "У Вас пока нет ни одного видео"
			};
			break;
	}
	return lang;
}

Lang.getDialog = function(lang_code){
	var lang = null;
	switch(lang_code){
		case Constant.EN_LANG:
			lang = {
				dialogPh: "Enter likes count",
				diamondsText: "Diamonds",
				sendText:  "Order",
				closeAccHead: "Private account",
				closeAccText: "Your account is private, please open it if you want to get likes! Then update main page or relogin to the app.",
				closeAccBut: "Ok"
			};
			break;
		case Constant.RU_LANG:
			lang = {
				dialogPh: "Введите количество лайков",
				diamondsText: "Диаманты",
				sendText:  "Заказать",
				closeAccHead: "Приватный аккаунт",
				closeAccText: "У Вас приватный аккаунт, пожалуйста, откройте его, если вы хотите накручивать лайки! Затем обновите страницу или перезайдите в приложение.",
				closeAccBut: "Ок"
			};
			break;
	}
	return lang;
}

Lang.getTasks = function(lang_code){
	var lang = null;
	switch(lang_code){
		case Constant.EN_LANG:
			lang = {
				likesText: "likes",
				followersText: "followers",
				ofText: "of",
				tasksNoQuestText: "You have no tasks yet"
			};
			break;
		case Constant.RU_LANG:
			lang = {
				likesText: "лайки",
				followersText: "подписки",
				ofText: "из",
				tasksNoQuestText: "У Вас пока нет ни одного задания"
			};
			break;
	}
	return lang;
}

Lang.getEarn = function(lang_code){
	var lang = null;
	switch(lang_code){
		case Constant.EN_LANG:
			lang = {
				startText: "Start earning diamonds",
				earnedText: "earned",
				speedText: "speed",
				ratingButText: "User's rating"
			};
			break;
		case Constant.RU_LANG:
			lang = {
				startText: "Начать зарабатывать диаманты",
				earnedText: "заработано",
				speedText: "скорость",
				ratingButText: "Рейтинг пользователей"
			};
			break;
	}
	return lang;
}

Lang.getBid = function(lang_code){
	var lang = null;
	switch(lang_code){
		case Constant.EN_LANG:
			lang = {
				likesButText: "Likes",
				subsButText: "Followers",
				warningText: "Users can unfollow, but they will get a serious penalty",
				bidLikeNoQuestText: "You have no videos yet",

				// bid likes
				listBut: "From list",

				// bid followers
				accBut: "This account",

				linkBut: "Link",
				linkLikePh: "Link on video",
				linkSubsPh: "Link on user's chanel",
				likesPh:  "Enter likes count",
				subsPh:  "Enter followers count",
				diamondsText: "Diamonds",
				startText: "Order",

				acceptHeadText: "Subscribes is not activated",
				acceptButText: "Activate",
				acceptMainText: "When you activate subscribes, you will exchange subscribes when you mine"
			};
			break;
		case Constant.RU_LANG:
			lang = {
				likesButText: "Лайки",
				subsButText: "Подписчики",
				warningText: "Пользователи могут отписываться, но за это их ожидает серьезный штраф",
				bidLikeNoQuestText: "У Вас пока нет ни одного видео",

				// bid likes
				listBut: "Из списка",

				// bid followers
				accBut: "На этот аккаунт",

				linkBut: "По ссылке",
				linkLikePh: "Ссылка на видео",
				linkSubsPh: "Ссылка на канал",
				likesPh:  "Введите количество лайков",
				subsPh:  "Введите количество подписчиков",
				diamondsText: "Диаманты",
				startText: "Заказать",

				acceptHeadText: "Подписки не активированы",
				acceptButText: "Активировать",
				acceptMainText: "Активируя накрутку подписчиков, Вы также будете обмениваться подписками при заработке"
			};
			break;
	}
	return lang;
}

Lang.getBot = function(lang_code){
	var lang = null;
	switch(lang_code){
		case Constant.EN_LANG:
			lang = {
				text: "Diamonds mining",
				title: "CometBoost",
				ticker: "CometBoost"
			};
			break;
		case Constant.UA_LANG:
		case Constant.BE_LANG:
		case Constant.RU_LANG:
			lang = {
				text: "Добыча диамантов",
				title: "CometBoost",
				ticker: "CometBoost"
			};
			break;
		default:
			lang = {
				text: "Diamonds mining",
				title: "CometBoost",
				ticker: "CometBoost"
			};
	}
	return lang;
}

Lang.getMessages = function(lang_code){
	var lang = null;
	switch(lang_code){
		case Constant.EN_LANG:
			lang = {
				bidOk: "The order was successful",
				bidFail: "The order failed",
				mhFail: "Can not get a data from the page",
				loginFail: "Authorization failed, check your login and password",
				connectErr: "Connection error, try again",
				readErr: "Connection error, try again",
				writeErr: "Error writing, try again",
				runErr: "Error running, try again",
				stopErr: "Error stopping, try again",
				donateErr: "Error, try again",
				donateBuyOk: "The purchase was successful",
				donateBuyErr: "Error with a purchase. Please contact us",
				checkoutText: "Checkout",
				verifyErr: "Verification error",
				premiumText: "Premium account",
				activeEarnText: "Mining diamonds is activated",
				newsServerErr: "Error with connecting to server",
				newsServerOk: "OK",

				bidLikesTitle: "Get likes",
				bidSubsTitle: "Get followers",
				tasksTitle: "My tasks",
				donateTitle: "Shop",
				earnTitle: "Diamonds mining",
				newsTitle: "News",
				guideNextText: "Next",
				guideReadyText: "Ready",
				turboBoughtText: "Owned"
			};
			break;
		case Constant.RU_LANG:
			lang = {
				bidOk: "Заказ оформлен успешно",
				bidFail: "Сделать заказ не удалось",
				mhFail: "Не удалось получить данные с записи",
				loginFail: "Не удалось войти в аккаунт, проверьте логин и пароль",
				connectErr: "Ошибка соединения, попробуйте еще раз",
				readErr: "Ошибка соединения, попробуйте еще раз",
				writeErr: "Ошибка записи, попробуйте еще раз",
				runErr: "Ошибка запуска, попробуйте еще раз",
				stopErr: "Ошибка остановки, попробуйте еще раз",
				donateErr: "Произошла ошибка, попробуйте снова",
				donateBuyOk: "Покупка оформлена успешно",
				donateBuyErr: "Произошла ошибка при покупке. Eсли проблема не решится, то напишите в поддержку",
				checkoutText: "Оформление покупки",
				verifyErr: "Ошибка верификации",
				premiumText: "Премиум аккаунт",
				activeEarnText: "Добыча диамантов активирована",
				newsServerErr: "Произошла ошибка при соединении с сервером",
				newsServerOk: "ОК",

				bidLikesTitle: "Получить лайки",
				bidSubsTitle: "Получить подписки",
				tasksTitle: "Мои задания",
				donateTitle: "Магазин",
				earnTitle: "Добыча диамантов",
				newsTitle: "Новости",
				guideNextText: "Далее",
				guideReadyText: "Готово",
				turboBoughtText: "Приобретено"
			};
			break;
	}
	return lang;
}

Lang.getCorrects = function(lang_code){
	var lang = null;
	switch(lang_code){
		case Constant.EN_LANG:
			lang = {
				enterLink: "Enter a link on YouTube page video",
				emptyLink: "Enter a link on YouTube page video",
				notExistLink: "Link doesn't exist, try another one",
				noCoins: "You don't have enough diamonds",
				errNegative: "The number can not be negative",
				errNumber: "Enter a number",
				minMaxLikes: "A number must be from " + Constant.MIN_COUNT_LIKE + " to " + Constant.MAX_COUNT_LIKE + "",
				minMaxSubs: "A number must be from " + Constant.MIN_COUNT_SUBS + " to " + Constant.MAX_COUNT_SUBS + "",
				minMaxPremLikes: "A number must be from 1 to " + Constant.MAX_PREM_COUNT_LIKE + "",
				minMaxPremSubs: "A number must be from 1 to " + Constant.MAX_PREM_COUNT_SUBS + ""
			};
			break;
		case Constant.RU_LANG:
			lang = {
				enterLink: "Введите ссылку на страницу c YouTube видео",
				emptyLink: "Введите ссылку на страницу с YouTube видео",
				notExistLink: "Ссылка не существует, попробуйте другую",
				noCoins: "У вас не достаточно диамантов",
				errNegative: "Число не может быть отрицательным",
				errNumber: "Введите число",
				minMaxLikes: "Вводимое число должно быть от " + Constant.MIN_COUNT_LIKE + " до " + Constant.MAX_COUNT_LIKE + "",
				minMaxSubs: "Вводимое число должно быть от " + Constant.MIN_COUNT_SUBS + " до " + Constant.MAX_COUNT_SUBS + "",
				minMaxPremLikes: "Вводимое число должно быть от 1 до " + Constant.MAX_PREM_COUNT_LIKE + "",
				minMaxPremSubs: "Вводимое число должно быть от 1 до " + Constant.MAX_PREM_COUNT_SUBS + ""
			};
			break;
	}
	return lang;
}

Lang.getDonate = function(lang_code){
	var lang = null;
	switch(lang_code){
		case Constant.EN_LANG:
			lang = {
				diamondsButText: "Diamonds",
				premiumButText: "Premium",
				turboButText: "Turbo",
				
				emptyField: "empty",
				popularText: "POPULAR",
				bestValueText: "BEST VALUE",
				buyButText: "Buy",
				
				premiumFirstText: "no ads in application",
				premiumSecondText: "you can disable subscribe to other users in the mining of diamonds",
				premiumThirdText: "increase the number of orders limits",
				premiumFourthText: "cancel penalty for the cancellation of the task",
				
				turboLightHeadText: "Turbo light",
				turboMediumHeadText: "Turbo medium",
				turbohardHeadText: "Turbo powerful",

				turboGreenFirstText: "for FREE 7 days",
				turboGreenSecondText: "300% mining speed",
				turboGreenThirdText: "increase speed limits",
				turboGreenFourthText: "for one month",

				turboBlueFirstText: "500% mining speed",
				turboBlueSecondText: "your tasks complete 2 times faster than others",
				turboBlueThirdText: "increase speed limits",
				turboBlueFourthText: "for one month",

				turboRedFirstText: "1000% mining speed",
				turboRedSecondText: "your tasks complete 3 times faster than others",
				turboRedThirdText: "increase speed limits",
				turboRedFourthText: "for one month",

				turboBoughtText: "Owned"
			};
			break;
		case Constant.RU_LANG:
			lang = {
				diamondsButText: "Диаманты",
				premiumButText: "Премиум",
				turboButText: "Турбо",
				
				emptyField: "пусто",
				popularText: "ПОПУЛЯРНЫЙ",
				bestValueText: "ЛУЧШАЯ ЦЕНА",
				savingText: "ЭКОНОМИЯ",
				buyButText: "Купить",
				
				premiumFirstText: "отключение рекламы в приложении",
				premiumSecondText: "можно не подписываться на других пользователей при добыче диамантов",
				premiumThirdText: "увеличение лимитов на заказы",
				premiumFourthText: "отмена штрафа за отмену задания",
				
				turboLightHeadText: "Турбо легкий",
				turboMediumHeadText: "Турбо средний",
				turboHardHeadText: "Турбо мощный",

				turboGreenFirstText: "бесплатно 7 дней",
				turboGreenSecondText: "скорость заработка 300%",
				turboGreenThirdText: "увеличение скоростных лимитов",
				turboGreenFourthText: "на 1 месяц",

				turboBlueFirstText: "скорость заработка 500%",
				turboBlueSecondText: "ваши задания выполняются в 2 раза быстрее других",
				turboBlueThirdText: "увеличение скоростных лимитов",
				turboBlueFourthText: "на 1 месяц",

				turboRedFirstText: "скорость заработка 1000%",
				turboRedSecondText: "ваши задания выполняются в 3 раза быстрее других",
				turboRedThirdText: "увеличение скоростных лимитов",
				turboRedFourthText: "на 1 месяц",

				turboBoughtText: "Приобретено"
			};
			break;
	}
	return lang;
}

Lang.getSettings = function(lang_code){
	var lang = null;
	switch(lang_code){
		case Constant.EN_LANG:
			lang = {
				settingsText: "Settings",
				newVersionText: "A new version: ",
				updateButText: "Update",
				premiumAccText: "Premium account",
				followEarnText: "Follow in earning",
				autoEarnText: "Auto mining after authorization",
				guideText: "Tutorial",
				rateText: "Rate the application",
				otherAppText: "Others our applications:",
				privacyText: "User aggreement",
				exitAccText: "Log out"
			};
			break;
		case Constant.RU_LANG:
			lang = {
				settingsText: "Настройки",
				newVersionText: "Новая версия: ",
				updateButText: "Обновить",
				premiumAccText: "Премиум аккаунт",
				followEarnText: "Подписка в заработке",
				autoEarnText: "Автоматическая добыча при авторизации",
				guideText: "Руководство",
				rateText: "Оцените приложение",
				otherAppText: "Другие наши приложения:",
				privacyText: "Пользовательское соглашение",
				exitAccText: "Выйти из аккаунта"
			};
			break;
	}
	return lang;
}

Lang.getAuthTrouble = function(lang_code){
	var lang = null;
	switch(lang_code){
		case Constant.EN_LANG:
			lang = {
				backText: "Authorization troubles",
				stepOneText: "Step 1",
				stepOneContent: "Click on the 'Authorization' button",
				stepTwoText: "Step 2",
				stepTwoContent: "Log in by your account YouTube opened through the browser",
				stepThreeText: "Step 3",
				stepThreeContent: "After you have logged into your account YouTube - browser must close in a few seconds and you'll redirect to the home page of application. If the browser will not close - close it - just click on the X in the upper right corner.",
				goodInetText: "*You must have a good Internet connection",
				problemText: "If you still can't log in:",
				problemListText: "If you cound't log in the first time",
				problemOneText: "try one more time",
				problemTwoText: "try restart the application",
				problemThreeText: "try to reinstall the application",
				nothingText: "If above suggestions will not help you",
				feedBackButText: "Feedback us"
			};
			break;
		case Constant.RU_LANG:
			lang = {
				backText: "Проблемы с авторизацией",
				stepOneText: "Шаг 1",
				stepOneContent: "Нажмите на кнопку “Авторизация”",
				stepTwoText: "Шаг 2",
				stepTwoContent: "Авторизируйтесь в вашем аккаунте YouTube через открывшийся браузер любым способом",
				stepThreeText: "Шаг 3",
				stepThreeContent: "После того как вы зашли на свой аккаунт YouTube - браузер должен закрытся через несколько секунд и вы перейдете на главную страницу приложения. Если браузер не закрылся - закройте его самостоятельно, нажав на крестик в правом верхнем углу.",
				goodInetText: "*У Вас должно быть хорошее интернет соединение",
				problemText: "В случае проблемы:",
				problemListText: "Если вам не удалось зайти с первого раза",
				problemOneText: "повторите попытку",
				problemTwoText: "попробуйте перезапустить приложение на телефоне и заново войти",
				problemThreeText: "переустановите приложение",
				nothingText: "Если ни один из советов вам не помог",
				feedBackButText: "Связаться с нами"
			};
			break;
	}
	return lang;
}

Lang.getGuide = function(lang_code){
	var lang = null;
	switch(lang_code){
		case Constant.EN_LANG:
			lang = {
				guideCoinsText: "Number of your diamonds",
				guideEarnText: "Button for mining diamonds",
				guideBidText: "Get likes",
				guideTasksText: "Your tasks",
				guideDonateText: "Shop",
				guideMainText: "Main profile",
				guideNewsText: "News",
				guideQuestHintText: "Tap on the any video for get likes",
				guideNextButText: "Next"
			};
			break;
		case Constant.RU_LANG:
			lang = {
				guideCoinsText: "Количество ваших диамантов",
				guideEarnText: "Кнопка перехода для заработка диамантов",
				guideBidText: "Накрутка",
				guideTasksText: "Ваши задания",
				guideDonateText: "Магазин",
				guideMainText: "Ваш профиль",
				guideNewsText: "Новости",
				guideQuestHintText: "Нажмите на видео на которое необходимо накрутить лайки",
				guideNextButText: "Далее"
			};
			break;
	}
	return lang;
}

Lang.getTop = function(lang_code){
	var lang = null;
	switch(lang_code){
		case Constant.EN_LANG:
			lang = {
				backText: "Rating",
				prizeTimeText: "The competition will end after:",
				tasksCompleteText: "Completed tasks:",
				dialogText: "Mine diamonds, take top places and get prizes",
				dialogPlaceText: "Place",
				dialogFirstPrize: Constant.TOP_PLACE_FIRST_PRIZE,
				dialogSecondPrize: Constant.TOP_PLACE_SECOND_PRIZE,
				dialogThirdPrize: Constant.TOP_PLACE_THIRD_PRIZE,
				dialogFourthPrize: Constant.TOP_PLACE_FOURTH_PRIZE,
				dialogFifthPrize: Constant.TOP_PLACE_FIFTH_PRIZE,
				dialogButText: "Ok"
			};
			break;
		case Constant.RU_LANG:
			lang = {
				backText: "Рейтинг",
				prizeTimeText: "До выдачи призов осталось:",
				tasksCompleteText: "Заданий выполнено:",
				dialogText: "Добывайте диаманты, занимайте призовые места в рейтинге и получайте призы",
				dialogPlaceText: "Место",
				dialogFirstPrize: Constant.TOP_PLACE_FIRST_PRIZE,
				dialogSecondPrize: Constant.TOP_PLACE_SECOND_PRIZE,
				dialogThirdPrize: Constant.TOP_PLACE_THIRD_PRIZE,
				dialogFourthPrize: Constant.TOP_PLACE_FOURTH_PRIZE,
				dialogFifthPrize: Constant.TOP_PLACE_FIFTH_PRIZE,
				dialogButText: "Ок"
			};
			break;
	}
	return lang;
}

Lang.getLvlPrize = function(lang_code){
	var lang = null;
	switch(lang_code){
		case Constant.EN_LANG:
			lang = {
				lvlNameText: "Prizes",

				lvlLevelText: " level",
				andPrizeText: " and ",
				turboPrizeText: " for one week"
			};
			break;
		case Constant.RU_LANG:
			lang = {
				lvlNameText: "Награды",

				lvlLevelText: " уровень",
				andPrizeText: " и ",
				turboPrizeText: " в течении недели"
			};
			break;
	}
	return lang;
}

Lang.getMineAd = function(lang_code){
	var lang = null;
	switch(lang_code){
		case Constant.EN_LANG:
			lang = {
				installButText: "Install"
			};
			break;
		case Constant.RU_LANG:
			lang = {
				installButText: "Установить"
			};
			break;
	}
	return lang;
}

Lang.getPrivacy = function(lang_code){
	var lang = null;
	switch(lang_code){
		case Constant.EN_LANG:
			lang = {
				backText: "User aggreement",

				point1Text: "1. The application CometBoost (next the application) was created for swap likes, followers on YouTube between interested people (next Users) by dint of a special currency (next Diamonds) and tried next:",
				point1Elem1Text: "1.1 mine and buy Diamonds;",
				point1Elem2Text: "1.2 get likes, followers;",
				point1Elem3Text: "1.3 buy a premium account in the application;",
				point1Elem4Text: "1.4 increase speed limits by dint of turbo;",
				point1Elem5Text: "1.5 feedback from the application support;",
				point2Text: "2. The application doesn't guarantee the execution time of orders and their cost.",
				point3Text: "3. The application can save User's data on User's device and on application's servers for work correctly.",
				point4Text: "4. The application reserves the rights at its discretion to carry out any change and/or supplement this User Agreement at any time without prior and/or subsequent notification to the User. The new version of the User Agreement comes into force from the moment of its placement in the application.",
				point5Text: "5. In case of disagreement user with any of the provisions of the User Agreement, the User shall not use the application. In case, if the application any changes were made to the User Agreement, with which the user does not agree, the latter obliged to stop using the application.",
				point6Text: "6. Current User Aggreement compulsory for all application's Users.",
				point7Text: "7. Creators of the application (next ruboss) don't guarantee:",
				point7Elem1Text: "7.1 uninterrupted work of the application;",
				point7Elem2Text: "7.2 errorless work of the application;",
				point7Elem3Text: "7.3 the application will not be typos or errors in the functional of the application;",
				point8Text: "8. ruboss is not be liable, including, but not limited to, for any material or moral damages caused by the use of or inability to use, the user application, as well as for any consequences of unauthorized users/illegal access by third parties to the User authorization data (login, password), a computer or personal data last.",
				point9Text: "9. The application is not affiliated and approved by YouTube.",
				point10Text: "10. ruboss warns, that in case of extremely automated processing of personal data are not responsible for the accuracy and reliability of personal data entered by the user, and user decision and arising in connection with the legal consequences.",
				point11Text: "11. ruboss doesn't guarantee, that after end of using the application by the user his data will be removed in time interval."
			};
			break;
		case Constant.RU_LANG:
			lang = {
				backText: "Пользовательское соглашение",

				point1Text: "1. Приложение CometBoost (далее Приложение) создано для обмена лайками, подписчиками на сервисе YouTube между заинтересованными лицами (далее Пользователями) с помощью специальой валюты (далее Диаманты) и позволяет следующее:",
				point1Elem1Text: "1.1 Накрутка или покупка Диамантов;",
				point1Elem2Text: "1.2 Накрутка лайков, подписчиков;",
				point1Elem3Text: "1.3 Покупка премиум аккаунта в Приложении;",
				point1Elem4Text: "1.4 Увеличение скоростных лимитов с помощью турбо подписки;",
				point1Elem5Text: "1.5 Получение помощи от технической поддержки Приложения;",
				point2Text: "2. Приложение не дает никаких гарантий относительно времени выполнения заказов и их стоимости.",
				point3Text: "3. Приложение может сохранять данные о Пользователе на устройстве пользователя, а так же на серверах для корректной работы.",
				point4Text: "4. Приложение оставляет за собой право осуществлять любые изменения и/или дополнение настоящего Пользовательского соглашения в любое время без предворительного и/или последующего уведомления. Новая версия Пользовательского соглашения вступает в силу с момента ее размещения в Приложении.",
				point5Text: "5. В случае несогласия Пользователя с каким-либо из положений Пользовательского соглашения, Пользователь не вправе использовать приложение. В случае, если в Пользовательское соглашение были внесены изменения, с которыми Пользователь не согласен, то последний обязан прекратить использование приложения.",
				point6Text: "6. Настоящее Пользовательское соглашение обязательно для всех Пользователей приложения.",
				point7Text: "7. Создатели приложения (далее ruboss) не гарантируют, что:",
				point7Elem1Text: "7.1 работа Приложения будет бесперебойной;",
				point7Elem2Text: "7.2 работа Приложения будет безошибочной;",
				point7Elem3Text: "7.3 в Приложении будут отсутствовать опечатки или ошибки в функционале Приложения;",
				point8Text: "8. ruboss не несет ответственности, в том числе, но не ограничиваясь, за любые материальные или моральные убытки, причененные из-за использования либо невозможности использования Пользователями Приложения, а также за любые последствия несанкционированного Пользователем / незаконного доступа третьих лиц к данным авторизации Пользователя (логин, пароль) либо личной информации последнего.",
				point9Text: "9. Приложение не аффилировано и не одобрено YouTube.",
				point10Text: "10. ruboss предупреждает, что не несет ответственность за правильность вводимых Пользователем данных, за принятые Пользователем решения и за возникшие в связи с этим последствия.",
				point11Text: "11. ruboss не гарантирует, что после прекращения использования Пользователем приложения его данные будут удалены в определенный промежуток времени."
			};
			break;
	}
	return lang;
}