var Manager = Base.extend({
	status: null,
	dataManager: null,
	user: null,
	bot: null,
	browser: null,
	connector: null,
	$rootScope: null,
	
	constructor: function($rootScope){
		Manager.instance = this;
		this.user = new User();
		this.dataManager = new DataManager(this.user);
		this.$rootScope = $rootScope;
		this.browser = new Browser(this.user);
		this.connector = new Connector(this.user);
		this.bot = new Bot(this, this.connector, this.dataManager, this.browser.getBrowser());
	},
	
	/* get and set Manager.status */
	setStatus: function(status){
		this.status = status;
	},
	
	getStatus: function(){
		return this.status;
	},
	
	/* get and set Manager.dataManager */
	setDataManager: function(dataManager){
		this.dataManager = dataManager;
	},
	
	getDataManager: function(){
		return this.dataManager;
	},
	
	getAppVersion: function(){
		return Constant.APP_VERSION;
	},

	/* get and set Manager.user */
	setUser: function(user){
		this.user = user;
	},
	
	getUser: function(){
		return this.user;
	},

	/* get and set Manager.bot */
	setBot: function(bot){
		this.bot = bot;
	},
	
	getBot: function(){
		return this.bot;
	},

	/* get and set Manager.browser */
	setBrowser: function(browser){
		this.browser = browser;
	},
	
	getBrowser: function(){
		return this.browser;
	},
	
	/* get and set Manager.connector */
	setConnector: function(connector){
		this.connector = connector;
	},
	
	getConnector: function(){
		return this.connector;
	},
		
	payForQuest: function(price, earned){
		var cash = this.user.getCash();
		cash.setFreeSum(cash.getFreeSum() + price);
		this.user.setCash(cash);
		this.$rootScope.freeSum = cash.getFreeSum();
		this.$rootScope.earned = earned;
		this.$rootScope.$applyAsync();
	},
	
	setCash: function(){
		this.$rootScope.freeSum = this.user.getCash().getFreeSum();
		this.$rootScope.$applyAsync();
	},
	
	setSpeed: function(speed){
		var speeds = [0, 3.1, 5.1, 8.1, 3.1];
		var bonus = 100 * speeds[this.user.getTurbo()];
		speed = (speed / Constant.maxSpeed) * 100;
		if(speed < 30)
			speed = 30;
		speed = parseInt(speed,10) + bonus;
		this.$rootScope.speedVal = speed + "%";
		this.$rootScope.$applyAsync();
	}
},{ 
	instance: this
});