var User = Base.extend({
	nick: null,
	id: null,
	email: null,
	subscribers: null,
	viewsCount: null,
	videos: null,
	authData: null,
	cash: null,
	xpInfo: null,
	profileAvatar: null,
	lang: null,
	premium: null,
	turbo: 0,
	settings: [],
	achieves: null,
	rtime: null,		//reg time ago
	channel: null,
	
	constructor: function(){},

	/* log in to User account */
	login: function(){},

	/* log out from User account */
	logout: function(){},
	
	/* get and set User.nick */
	setNick: function(nick){
		this.nick = nick;
	},
	
	getNick: function(){
		return this.nick;
	},
	
	/* get and set User.id */
	setId: function(id){
		this.id = id;
	},
	
	setPremium: function(premium){
		this.premium = (premium == 0 ? false : true);
	},
	
	getPremium: function(){
		return this.premium;
	},
	
	setRtime: function(rtime){
		this.rtime = rtime;
	},
	
	isSafeUser: function(){
		return this.rtime >= Constant.STAY_SAFE_USER_TIME ? true : false;
	},
	
	getRtime: function(){
		return this.rtime;
	},
	
	setTurbo: function(turbo){
		this.turbo = turbo;
	},
	
	getTurbo: function(){
		return this.turbo;
	},
	
	getId: function(){
		return this.id;
	},

	/* get and set User.email */
	setEmail: function(email){
		this.email = email;
	},
	
	getEmail: function(){
		return this.email;
	},
	
	/* get and set User.subscribers */
	setSubscribers: function(subscribers){
		this.subscribers = subscribers;
	},
	
	getSubscribers: function(){
		return this.subscribers;
	},
	
	/* get and set User.viewsCount */
	setViewsCount: function(viewsCount){
		this.viewsCount = viewsCount;
	},
	
	getViewsCount: function(){
		return this.viewsCount;
	},
	
	/* get and set User.videos */
	setVideos: function(videos){
		this.videos = videos;
	},
	
	getVideos: function(){
		return this.videos;
	},
	
	/* get and set User.authData */
	setAuthData: function(authData){
		this.authData = authData;
	},
	
	getAuthData: function(){
		return this.authData;
	},
	
	/* get and set User.cash */
	setCash: function(cash){
		this.cash = cash;
	},
	
	getCash: function(){
		return this.cash;
	},
	
	setAchieves: function(achieves){
		if(achieves != null)
			this.achieves = achieves;
		else
			this.achieves = new Array();
	},
	
	getAchieves: function(){
		return this.achieves;
	},
	
	setXpInfo: function(xpInfo){
		this.xpInfo = xpInfo;
	},
	
	getXpInfo: function(){
		return this.xpInfo;
	},
	
	changeCash: function(free, busy){
		this.cash.changeSums(free, busy);
	},
	
	getProfileAvatar: function(){
		return this.profileAvatar;
	},
	
	setLang: function(lang){
		this.lang = lang;
	},
	
	getLang: function(){
		return this.lang;
	},
	
	setSetting: function(name, value){
		this.settings["s_"+name] = value;
	},
	
	isFirstTime: function(){
		return this.settings["s_"+Constant.FIRSTTIME_SETTING] == 1 ? true : false;
	},
	
	getSetting: function(name){
		return this.settings["s_"+name];
	},
	
	getChannel:function(){
		return this.channel;
	},
	
	reset: function(){
		this.nick = null;
		this.id = null;
		this.email = null;
		this.subscribers = null;
		this.viewsCount = null;
		this.videos = null;
		this.authData = null;
		this.cash = null;
		this.profileAvatar = null;
	},
	
	setUserInfo: function(userInfo){
		this.nick = userInfo.getNick();
		this.email = userInfo.getEmail();
		this.videos = userInfo.getVideos();
		this.subscribers = userInfo.getSubscribers();
		this.profileAvatar = userInfo.getProfileAvatar();
		this.viewsCount = userInfo.getViewsCount();
		this.channel = userInfo.getChannel();
	}
});